<?php

require_once('./setup_admin.php');

$conf_file = GT_CATEGORY_CONF_FILE;
$template = 'edit_category.tpl';

$old_data = get_serial_data( $conf_file );
$request = $_REQUEST['s'];

if ( isset( $_REQUEST['delete'] )){
        
    if ( !isset($old_data[$request['id']] ) ) {
        $errors[] = '削除しようとしたデータは存在しません。';
        $smarty = new smarty_c;
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }

    $outdata = $old_data;
    unset( $outdata[$request['id']] );

    update_serial_data( $conf_file, $outdata );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
} elseif ( isset( $_REQUEST['update'] )){
    $ret = check_convert_requested_data( $request, 
        $output, $display, $errors );
    if ( !$ret ) {
        $smarty = new smarty_c;
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }
    elseif ( !isset($old_data[$request['id']] ) ) {
        $errors[] = '更新しようとしたデータは存在しません。';
        $smarty = new smarty_c;
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }else if ( $output == $old_data[$request['id']] ) {
        $errors[] = '旧データから、修正されていません。';
        $smarty = new smarty_c;
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }

    $outdata = $old_data;
    $outdata[$request['id']] = $output;

    update_serial_data( $conf_file, $outdata );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
}
elseif ( isset( $_REQUEST['insert'] )){

    $ret = check_convert_requested_data( $request, 
	$output, $display, $errors );

    if ( !$ret ) {
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
	} elseif ( isset($old_data[$display['id']]) ) {
        $errors[] = 'そのidは既に使用されています。';
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }
    $outdata = $old_data;
    $outdata[$output['id']] = $output;
    update_serial_data( $conf_file, $outdata );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
} 
elseif ( isset( $_REQUEST['up'] ) ){
    $ret = check_convert_requested_data( $request, 
	$output, $display, $errors );

    $outdata = array();
    $success = false;

    foreach ( $old_data as $k => $v ){
        if ( $k == $display['id'] ){
            if ( isset($last_record ) ){
                $outdata[$k] = $v;
                $success = true;
            } else {
                $errors[] = 'それ以上、上にはできません。';
                $smarty = new smarty_c;
                $smarty->assign( 's',$display );
                $smarty->assign( 'sl',$old_data );
                $smarty->assign( 'errors', $errors );
                $smarty->display($template);
                exit;
            }
        } else {
            if ( isset($last_record) ){
                $outdata[$last_key] = $last_record;
            } else {
            }
            $last_key = $k;
            $last_record = $v;
        }
    }
    if ( $success ){
        $outdata[$last_key] = $last_record;
    } else {
        $errors[] = '指定されたＩＤの行がありません。';
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }

    update_serial_data( $conf_file, $outdata );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
}
elseif ( isset( $_REQUEST['down'] ) ){
    $ret = check_convert_requested_data( $request, 
	$output, $display, $errors );

    $outdata = array();
    $success = false;

    foreach ( $old_data as $k => $v ){
        if ( $k == $display['id'] ){
            $saved_key = $k;
            $saved_record = $v;
        } else {
            $outdata[$k] = $v;
            if ( isset( $saved_record ) ){
                $outdata[$saved_key] = $saved_record;
                unset($saved_key);
                unset($saved_record);
                $success = true;
            }
        }
    }
    if ( $success ){
    } else {
        $errors[] = '下へ移動できませんでした。';
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }
    update_serial_data( $conf_file, $outdata );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
}
else {
    $smarty = new smarty_c;
    $smarty->assign( 'sl',$old_data );
    $smarty->display($template);
    exit;
}

function check_convert_requested_data( $input, &$output, &$display, &$errors ){

    $ret = true;

    $display = $input;
    
    if ( !ctype_digit($input['id'] ) ){
        $errors[] = 'カテゴリIDは、数字しか入力できません。';
        $ret = false;
    }
    elseif ( $input['id'] == 0 ){
        $errors[] = 'カテゴリIDは、０は入力できません。';
        $ret = false;
    }

    array_walk_recursive( $display, 'array_specialchars' );    

    $output['id'] = $display['id'];
    $output['name'] = $display['name'];
    return $ret;
}


?>
