<?php

require_once('./setup_admin.php');

$conf_file = GT_COMMENT_CONF_FILE;
$template = 'edit_comment.tpl';

$request = $_REQUEST['s'];

$old_data = get_serial_data( $conf_file );

if ( isset( $_REQUEST['update'] )){
        
    $ret = check_convert_requested_data( $request, 
	$output, $display, $errors );

    if ( !$ret ) {
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
	} else if ( $output == $old_data ) {
        $errors[] = '旧データから、修正されていません。';
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }

    update_serial_data( $conf_file, $output );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
}
else {
    $smarty = new smarty_c;
    $smarty->assign( 's',$old_data );
    $smarty->display($template);
    exit;
}

function check_convert_requested_data( $input, &$output, &$display, &$errors ){

    $ret = true;
    $display = $input;
    array_walk_recursive( $display, 'array_specialchars' );    

    if ( !ctype_digit($input['maxlen_author']) ){
        $errors[] = '名前最大長は、数字しか入力できません。';
        $ret = false;
    }
    if ( !ctype_digit($input['maxlen_mail']) ){
        $errors[] = 'メール最大長は、数字しか入力できません。';
        $ret = false;
    }
    if ( !ctype_digit($input['maxlen_url']) ){
        $errors[] = 'URL最大長は、数字しか入力できません。';
        $ret = false;
    }
    if ( !ctype_digit($input['maxlen_body']) ){
        $errors[] = 'コメント最大長は、数字しか入力できません。';
        $ret = false;
    }
    if ( $input['protect_by_question'] ){
        if ( !ctype_digit($input['question_date']) ){
            $errors[] = '日数は、数字しか入力できません。';
            $ret = false;
        }
        if ( !$input['question_question'] ){
            $errors[] = '質問は必ず入力してください。';
            $ret = false;
        }
        if ( !$input['question_answer'] ){
            $errors[] = '回答は必ず入力してください。';
            $ret = false;
        }
    }

    $output['maxlen_author'] = (int) $display['maxlen_author'];
    $output['maxlen_mail'] = (int) $display['maxlen_mail'];
    $output['maxlen_url'] = (int) $display['maxlen_url'];
    $output['maxlen_body'] = (int) $display['maxlen_body'];
    $output['protect_by_cookie'] = (bool) $display['protect_by_cookie'];
    $output['protect_by_question'] = (bool) $display['protect_by_question'];
    $output['question_date'] = (int) $display['question_date'];
    $output['question_question'] = trim($display['question_question']);
    $output['question_answer'] = trim($display['question_answer']);
    
    return $ret;
}


?>
