<?php

require_once('./setup_admin.php');

$conf_file = GT_TRACKBACK_CONF_FILE;
$template = 'edit_trackback.tpl';

$request = $_REQUEST['s'];

$old_data = get_serial_data( $conf_file );

if ( isset( $_REQUEST['update'] )){
        
    $ret = check_convert_requested_data( $request, 
	$output, $display, $errors );

    if ( !$ret ) {
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
	} else if ( $output == $old_data ) {
        $errors[] = '旧データから、修正されていません。';
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }

    update_serial_data( $conf_file, $output );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
}
else {
    $smarty = new smarty_c;
    $smarty->assign( 's',$old_data );
    $smarty->display($template);
    exit;
}

function check_convert_requested_data( $input, &$output, &$display, &$errors ){

    $ret = true;
    $display = $input;
    array_walk_recursive( $display, 'array_specialchars' );    

    if ( !ctype_digit($input['maxlen_title']) ){
        $errors[] = 'タイトル最大長は、数字しか入力できません。';
        $ret = false;
    }
    if ( !ctype_digit($input['maxlen_excerpt']) ){
        $errors[] = '要約最大長は、数字しか入力できません。';
        $ret = false;
    }
    if ( !ctype_digit($input['maxlen_url']) ){
        $errors[] = 'URL最大長は、数字しか入力できません。';
        $ret = false;
    }
    if ( !ctype_digit($input['maxlen_blog_name']) ){
        $errors[] = 'ブログ名最大長は、数字しか入力できません。';
        $ret = false;
    }
    if ( !preg_match( "/^[A-Z0-9a-z]*$/", trim($input['sup_string']) ) ){
        $errors[] = 'URL付加文字列は、英数字しか入力できません。';
        $ret = false;        
    }
    if ( $input['reject_user_agent'] <> '' ){
        ob_start();
        $preg_ret = preg_match($input['reject_user_agent'], 'dummy' );
        $preg_ret_message = ob_get_contents();
        ob_end_clean();
        if (  $preg_ret === false ){
            $errors[] = "拒否User-Agentの正規表現が正しくありません。" . $preg_ret_message;
            $ret = false;
        }
    }

    $output['maxlen_title'] = (int) $display['maxlen_title'];
    $output['maxlen_excerpt'] = (int) $display['maxlen_excerpt'];
    $output['maxlen_url'] = (int) $display['maxlen_url'];
    $output['sup_string'] = trim($display['sup_string']);
    $output['reject_user_agent'] = $display['reject_user_agent'];
    $output['maxlen_blog_name'] = (int) $display['maxlen_blog_name'];
    $output['hide_trackback_url'] = (bool) $display['hide_trackback_url'];
    $output['timelimit_trackback_url'] = (bool) $display['timelimit_trackback_url'];
    $output['timelimit_trackback_seed'] = $display['timelimit_trackback_seed'];
        
    return $ret;
}


?>
