<?php

define( 'GT_SERIAL_HEADER', '<?php exit(\'Error\');?>' );

function filter_request( $arg ){
    if ( which_view() == 'mobile_view' ){
        array_walk_recursive( $arg, 'array_sjis_to_utf');
        return $arg;
    } else {
        return $arg;
    }
}
function readlock(){
    $lock = lock_common( LOCK_SH );
    return $lock;
}
function writelock(){
    $lock = lock_common( LOCK_EX );
    return $lock;
}

function unlock(){
}

function lock_common( $l ){
    static $fp = false;
    if ( !$fp ){
        $fp = fopen( GT_LOCK_DIR . 'blog.lck', 'w+' );
        if ( !$fp ) return false;
    }
    $lock = flock( $fp, $l );
    if ( !$lock ) return false;
    return true;
}
function master_category(){
    static $data;
    if (!$data){
        $data = get_serial_data( GT_CATEGORY_CONF_FILE );
    }
    return $data;
}
function master_user(){
    static $data;
    if (!$data){
        $data = get_serial_data( GT_USER_CONF_FILE );
    }
    return $data;
}
function master_blog(){
    static $data;
    if (!$data){
        $data = get_serial_data( GT_BLOG_CONF_FILE );
    }
    return $data;
}
function master_comment(){
    static $data;
    if (!$data){
        $data = get_serial_data( GT_COMMENT_CONF_FILE );
    }
    return $data;
}
function master_trackback(){
    static $data;
    if (!$data){
        $data = get_serial_data( GT_TRACKBACK_CONF_FILE );
    }
    return $data;
}
function master_status(){
    return array('Publish' => '公開','Draft' =>'非公開' );
}
function master_upload(){
    static $data;
    if (!$data){
        $data = get_serial_data( GT_UPLOAD_CONF_FILE );
    }
    return $data;
}
function category_options() {
    $w = master_category();
    foreach ( $w as $k => $v ){
        $out[$k] = $v['name'];
    }
    return $out;
}
function user_options() {
    $w = master_user();
    foreach ( $w as $k => $v ){
        $out[$k] = $v['name'];
    }
    return $out;
}
function status_options(){
    return master_status();
}

function translate_entry_for_display( &$entry ){
    $master_category = master_category();
    $master_user = master_user();
    $entry_save = $entry;
    
    if (!$entry) return;
    array_walk_recursive( $entry, 'array_specialchars');

    $entry['introduction'] = convert_input_tag($entry_save['introduction']);
    $entry['body'] = convert_input_tag($entry_save['body']);
    $entry['url'] = htmlspecialchars( $entry_save['url'], ENT_QUOTES );

//    print_r($master_user);
    if ( $entry['nl2br'] ){
        $entry['introduction'] = nl2br( $entry['introduction'] );
        $entry['body'] = nl2br( $entry['body'] );
    }
    $entry['category_name'] = $master_category[$entry['category_id']]['name'];
    $entry['user_name'] = $master_user[$entry['user_id']]['name'];

}

/* smarty キャッシュ操作、ページ、エントリ、月ページ、エントリナビのクリア
　更新前キャッシュに対する操作で、
  キャッシュの更新前に呼ぶ(ページナビキャッシュクリアは、ここではやってない。）
*/
function list_update_smarty_cache_pre( $entry_id, 
  $old_date,$new_date, $old_status, $new_status, $old_category_id, $new_category_id ){


  if ( $old_status <> 'Publish' ) return array();
  $cache_all = read_cache('all');
  $cache_category = read_cache($old_category_id );

  foreach ( array( 'pc_view', 'mobile_view' ) as $view ){

    $last_page_number_all = count_to_last_page_number( count($cache_all), $view ); 
    $page_no_all = entry_id_to_belong_page_number( $entry_id, 'all', $view );

    // ページキャッシュ
	// 新ステータスが公開の場合（かつ日付の変更なしの時）
    // ALLの該当ページだけをクリア
    if ( $new_status == 'Publish' and $new_date == $old_date ){
        $ret_list[] = 'page|all|' . $page_no_all . '|' . $view;
    }
    // それ以外の場合（公開→非公開、削除）
	// ALLの該当ページ以降をクリア
    else {
        if ( $page_no_all !== 'last' ){
          for ( $i=$page_no_all; $i <= $last_page_number_all; $i++ ){
            $ret_list[] = 'page|all|' . $i . '|' . $view;
          }
        }else {
        // ページが減ってるかもしれない場合、、、
            $w_l_p  =  count_to_last_page_number_o( count($cache_all), $view );
            $w_l_p2 =    count_to_last_page_number_o( count($cache_all)-1, $view );
            if ( $w_l_p <> $w_l_p2 )
            $ret_list[] =  'page|all|' . $last_page_number_all . '|' . $view;
        }
        $ret_list[] = 'page|all|last|' . $view;
    }
    
    
    $last_page_number_category = count_to_last_page_number( count($cache_category), $view ); 
    $page_no_category = entry_id_to_belong_page_number( $entry_id, $old_category_id, $view );

	// カテゴリの更新がない、かつステータス変更がない（新ステータスが公開）場合
    //（かつ日付の変更なしの時）
	// 旧カテゴリ（新カテゴリと同じ）の該当ページだけをクリア
    if ( $new_category_id == $old_category_id and 
         $new_status == 'Publish' and $new_date == $old_date ){
        $ret_list[] = 'page|' . $old_category_id . '|' . $page_no_category . '|' . $view;
    }
	// それ以外の場合
	//旧カテゴリの該当ページ以降をクリア
    else {
      if ( $page_no_category !== 'last' ){
        for ( $i=$page_no_category; $i <= $last_page_number_category; $i++ ){
            $ret_list[] = 'page|' . $old_category_id .'|' . $i . '|' . $view;
        }
      } else {
        // ページが減るかもしれない時
            $w_l_p =  count_to_last_page_number_o( count($cache_category), $view );
            $w_l_p2 =  count_to_last_page_number_o( count($cache_category)-1, $view );
            if ( $w_l_p <> $w_l_p2 )
            $ret_list[] =  'page|' . $old_category_id .'|' . $last_page_number_category . '|' . $view;
      }
      $ret_list[] = 'page|' . $old_category_id . '|last|' . $view;
    }
  }
  //エントリキャッシュ
    $ret_list[] = 'entry|' . $entry_id;
  //月別ページキャッシュ
    $month = strftime( '%Y%m', $old_date );
    $ret_list[] = 'month|' . $month;
  //エントリナビキャッシュ
	//	該当エントリとその前後をクリア
    $ret_list[] = 'entry_navi|all|' . $entry_id;
    $key_w = array_search( $entry_id, $cache_all );
    if ( $key_w !== NULL ){
        if ( isset( $cache_all[$key_w-1] ) ) $ret_list[] = 'entry_navi|all|' . $cache_all[$key_w-1];
        if ( isset( $cache_all[$key_w+1] ) ) $ret_list[] = 'entry_navi|all|' . $cache_all[$key_w+1];
    }
    $ret_list[] = 'entry_navi|' . $old_category_id . '|' . $entry_id;
    $key_w = array_search( $entry_id, $cache_category );
    if ( $key_w !== NULL ){
        if ( isset( $cache_category[$key_w-1] ) ) $ret_list[] = 'entry_navi|' . $old_category_id . '|' . $cache_category[$key_w-1];
        if ( isset( $cache_category[$key_w+1] ) ) $ret_list[] = 'entry_navi|' . $old_category_id . '|' . $cache_category[$key_w+1];
    }
  //月別アーカイブ
    if ( $new_status == 'Publish' and $new_date == $old_date ){
    } else {
        $ret_list[] = 'months';
    }
  //カテゴリ別
    if ( $new_category_id == $old_category_id and 
         $new_status == 'Publish' and $new_date == $old_date ){
    } else {
        $ret_list[] = 'categories';
    }
    return $ret_list;
}

function list_update_smarty_cache_post( $entry_id, 
  $old_date,$new_date, $old_status, $new_status, $old_category_id, $new_category_id ){


  if ( $new_status <> 'Publish' ) return array();
  $cache_all = read_cache('all');
  $cache_category = read_cache($new_category_id );

  foreach ( array( 'pc_view', 'mobile_view' ) as $view ){

    $last_page_number_all = count_to_last_page_number( count($cache_all), $view ); 
    $page_no_all = entry_id_to_belong_page_number( $entry_id, 'all', $view );

    // ページキャッシュ
	// 旧ステータスが公開の場合（かつ日付の変更なしの時）
    // ALLの該当ページだけをクリア
    if ( $old_status == 'Publish' and $new_date == $old_date ){
        $ret_list[] = 'page|all|' . $page_no_all . '|' . $view;
    }
    // それ以外の場合（非公開、削除→公開）
	// ALLの該当ページ以降をクリア
    else {
        if ( $page_no_all !== 'last' ){
          for ( $i=$page_no_all; $i <= $last_page_number_all; $i++ ){
            $ret_list[] = 'page|all|' . $i . '|' . $view;
          }
        }else {
        // ページが増えてるかもしれない場合、、、
            $w_l_p  =  count_to_last_page_number_o( count($cache_all), $view );
            $w_l_p2 =    count_to_last_page_number_o( count($cache_all)-1, $view );
            if ( $w_l_p <> $w_l_p2 )
            $ret_list[] =  'page|all|' . $last_page_number_all . '|' . $view;
        }
        $ret_list[] = 'page|all|last|' . $view;
    }
    
    
    $last_page_number_category = count_to_last_page_number( count($cache_category), $view ); 
    $page_no_category = entry_id_to_belong_page_number( $entry_id, $new_category_id, $view );

	// カテゴリの更新がない、かつステータス変更がない（旧ステータスが公開）場合
    //（かつ日付の変更なしの時）
	// 新カテゴリ（旧カテゴリと同じ）の該当ページだけをクリア
    if ( $new_category_id == $old_category_id and 
         $old_status == 'Publish' and $new_date == $old_date ){
        $ret_list[] = 'page|' . $new_category_id . '|' . $page_no_category . '|' . $view;
    }
	// それ以外の場合
	//新カテゴリの該当ページ以降をクリア
    else {
      if ( $page_no_category !== 'last' ){
        for ( $i=$page_no_category; $i <= $last_page_number_category; $i++ ){
            $ret_list[] = 'page|' . $new_category_id .'|' . $i . '|' . $view;
        }
      } else {
        // ページが増えるかもしれない時
            $w_l_p =  count_to_last_page_number_o( count($cache_category), $view );
            $w_l_p2 =  count_to_last_page_number_o( count($cache_category)-1, $view );
            if ( $w_l_p <> $w_l_p2 )
                $ret_list[] =  'page|' . $new_category_id .'|' . $last_page_number_category . '|' . $view;
      }
      $ret_list[] = 'page|' . $new_category_id . '|last|' . $view;
    }
  }
  //エントリキャッシュ
    $ret_list[] = 'entry|' . $entry_id;
  //月別ページキャッシュ
    $month = strftime( '%Y%m', $new_date );
    $ret_list[] = 'month|' . $month;
  //エントリナビキャッシュ
	//	該当エントリとその前後をクリア
    $ret_list[] = 'entry_navi|all|' . $entry_id;
    $key_w = array_search( $entry_id, $cache_all );
    if ( $key_w !== NULL ){
        if ( isset( $cache_all[$key_w-1] ) ) $ret_list[] = 'entry_navi|all|' . $cache_all[$key_w-1];
        if ( isset( $cache_all[$key_w+1] ) ) $ret_list[] = 'entry_navi|all|' . $cache_all[$key_w+1];
    }
    $ret_list[] = 'entry_navi|' . $new_category_id . '|' . $entry_id;
    $key_w = array_search( $entry_id, $cache_category );
    if ( $key_w !== NULL ){
        if ( isset( $cache_category[$key_w-1] ) ) $ret_list[] = 'entry_navi|' . $new_category_id . '|' . $cache_category[$key_w-1];
        if ( isset( $cache_category[$key_w+1] ) ) $ret_list[] = 'entry_navi|' . $new_category_id . '|' . $cache_category[$key_w+1];
    }
    
  //月別アーカイブ
    if ( $old_status == 'Publish' and $new_date == $old_date ){
    } else {
        $ret_list[] = 'months';
    }
  //カテゴリ別
    if ( $new_category_id == $old_category_id and 
         $old_status == 'Publish' and $new_date == $old_date ){
    } else {
        $ret_list[] = 'categories';
    }
    return $ret_list;
}




function list_comment_smarty_cache( $entry_id, $category_id ){

  foreach ( array( 'pc_view', 'mobile_view' ) as $view ){

    $page_no_all = entry_id_to_belong_page_number( $entry_id, 'all', $view );

    $ret_list[] = 'page|all|' . $page_no_all . '|' . $view;
   
    $page_no_category = entry_id_to_belong_page_number( $entry_id, $category_id, $view );
    $ret_list[] = 'page|' . $category_id . '|' . $page_no_category . '|' . $view;
    
  }
  $ret_list[] = 'entry|' . $entry_id;
  $ret_list[] = 'recent_comments';
  return $ret_list;
}
function list_comment_update_smarty_cache( $entry_id ){

  $ret_list[] = 'entry|' . $entry_id;
  $ret_list[] = 'recent_comments';
  return $ret_list;
}
function list_trackback_smarty_cache( $entry_id, $category_id ){

  foreach ( array( 'pc_view', 'mobile_view' ) as $view ){

    $page_no_all = entry_id_to_belong_page_number( $entry_id, 'all', $view );

    $ret_list[] = 'page|all|' . $page_no_all . '|' . $view;
   
    $page_no_category = entry_id_to_belong_page_number( $entry_id, $category_id, $view );
    $ret_list[] = 'page|' . $category_id . '|' . $page_no_category . '|' . $view;
    
  }
  $ret_list[] = 'entry|' . $entry_id;
  $ret_list[] = 'recent_trackbacks';
  return $ret_list;
}
function list_trackback_update_smarty_cache( $entry_id ){

  $ret_list[] = 'entry|' . $entry_id;
  $ret_list[] = 'recent_trackbacks';
  return $ret_list;
}

/* 件数から、最終ページ番号を算出する。 */
function count_to_last_page_number ( $c_count, $view ){
    $master_blog = master_blog();
//print_r($master_blog);
    return (int) floor( ( count_to_last_page_number_o( $c_count, $view ) -1 )/ 
         $master_blog[$view]['past_page_snum'] ) + 1;
}
function count_to_last_page_number_o( $c_count, $view ) {
    $master_blog = master_blog();

    $last_entry_number = $c_count - 1;
    if ( $last_entry_number <  $master_blog[$view]['top_page_count'] ){
//      $last_page_number = -1;
      $last_page_number = 0;

    } else {
        $last_page_number =
                (int) ( ( $last_entry_number -  
                            $master_blog[$view]['top_page_count']
                           ) /
                           $master_blog[$view]['past_page_count'] 
                      ) + 1;
    }
//    echo 'a'. $last_page_number .'a';
    return $last_page_number;
}
/* エントリidから、それの属するページ番号を算出する。*/
function entry_id_to_belong_page_number( $entry_id, $category_id, $view ) {
    $master_blog = master_blog();
    $belong_page_number_o = entry_id_to_belong_page_number_o( $entry_id, $category_id, $view );
    if ( $belong_page_number_o === 'last' ) return 'last';
    else return (int) floor( ( $belong_page_number_o + 1 ) /  $master_blog[$view]['past_page_snum'] );
//    else return (int) floor( $belong_page_number_o /  $master_blog[$view]['past_page_snum'] );
}

function entry_id_to_belong_page_number_o( $entry_id, $category_id, $view ) {
//echo '&lt;';    echo $category_id;echo '*';
    $master_blog = master_blog();
    $cache = read_cache( $category_id );
    $last_page_number = count_to_last_page_number_o( count($cache), $view );
    $entry_loc = array_search( $entry_id, $cache );
    if ( $entry_loc === false ){
        user_error('存在しないエントリが参照されました。キャッシュが壊れてるかも。');
        return -1;
    }
    $w_page_number = (int) ($entry_loc /$master_blog[$view]['past_page_count'])+1;
    if ( $w_page_number > $last_page_number ) return 'last';
    else return $w_page_number;

}

function disp_first_last_cnumber( $page, $category_id, $view ){
        $master_blog = master_blog();
        $count_cache = count(read_cache($category_id));
        $last_page_number = count_to_last_page_number_o( $count_cache, $view );
        if ( $page === 'last' ){
            $disp_last_entry_number = $count_cache - 1;
            $disp_first_entry_number =
                ( $last_page_number ) *  $master_blog[$view]['past_page_count'];
        } else {
            $spage = $page-1;
            $disp_first_entry_number = $spage * $master_blog[$view]['past_page_snum'] *
                $master_blog[$view]['past_page_count'];
            $disp_last_entry_number = 
                min( $disp_first_entry_number + 
                     $master_blog[$view]['past_page_snum'] * $master_blog[$view]['past_page_count']
                     -1,
                     ($last_page_number) * ($master_blog[$view]['past_page_count']) - 1) ;
        }

        return array( $disp_first_entry_number, $disp_last_entry_number );
}

/* エントリキャッシュ操作関数群 */
function create_all_cache(){
    $last_data_number = get_last_entry_number();
    $cache_w = array();
    $cache_w_d = array();
    for ( $i = 0; $i <= $last_data_number; $i++ ){
        $entry = get_entry($i , false );
        if ( $entry['status'] == 'Publish' ) {
            $entry_ym = strftime( '%Y%m', $entry['date'] );
            $cache_w[$entry_ym]['all'][] = array( $entry['date'], $i );
            $cache_w[$entry_ym][$entry['category_id']][] = array( $entry['date'], $i );
        } elseif ( $entry['status'] == 'Draft' ) {
            $cache_w_d[] = $i;
        }
    }
    
    foreach ( $cache_w as $ym => $cache_ym ){
        foreach ( $cache_ym as $c=> $cache_ymc ){
            usort_rec_int ( $cache_w[$ym][$c], 0 );
        }
    }
//    echo '<pre>';
    foreach ( $cache_w as $ym => $cache_ym ){
        foreach ( $cache_ym as $c=> $cache_ymc ){
            foreach ( $cache_ymc as $k => $cache_ymck ){
                $cache[$ym][$c][$k] = $cache_ymck[1];
            }
        }
    }
//    echo '<pre>';
//    print_r($cache);
//    exit;    

    $ret = deleteDir (  GT_DATA_DIR . 'cache/' );
    if ( !$ret ) return $ret;
    $ret = mkdir( GT_DATA_DIR . 'cache/' );
    if ( !$ret ) return $ret;

    foreach ( (array) $cache as $ym => $cache_ym ){
        $ret = mkdir (  GT_DATA_DIR . 'cache/' . $ym );
        if ( !$ret ) return $ret;
        foreach ( $cache_ym as $c=> $cache_ymc ){
            $ret = update_csv_data( GT_DATA_DIR . 'cache/' . $ym . '/' . $c . '.php' , $cache_ymc );
            if ( !$ret ) return $ret;
        }
    }
    $ret = update_csv_data( GT_DATA_DIR . 'cache_s/draft.php', $cache_w_d);
    if ( !$ret ) return $ret;

    return true;
}
function update_cache( $date, $category_id, $category_id2 = 'no' ){

    if ( $category_id == $category_id2 ) {
        $category_id2 = 'no'; //数字のはずなので、、、手抜き
    }
    $month = $entry_ym = strftime( '%Y%m', $date );
    $last_data_number = get_last_entry_number();
    $cache_w = array();
    $request_ym = strftime( '%Y%m', $date );
    $cache_w[$request_ym]['all'] = array();
    $cache_w[$request_ym][$category_id] = array();
    if ( $category_id2 <> 'no' ) 
     $cache_w[$request_ym][$category_id2] = array();
    $cache_w_d = array();
    for ( $i = 0; $i <= $last_data_number; $i++ ){
        $entry = get_entry($i , false );
        if ( $entry['status'] == 'Publish' ){
            $entry_ym = strftime( '%Y%m', $entry['date'] );
            if ( $entry_ym <> $month ) continue;
            $cache_w[$entry_ym]['all'][] = array( $entry['date'], $i );
            if ( $entry['category_id'] == $category_id ) 
                $cache_w[$entry_ym][$category_id][] = array( $entry['date'], $i );
            elseif ( $entry['category_id'] == $category_id2 ) 
                $cache_w[$entry_ym][$category_id2][] = array( $entry['date'], $i );
        } elseif ( $entry['status'] == 'Draft' ) {
            $cache_w_d[] = $i;
        }
    }

//    echo '<pre>';
//    var_dump($category_id);    var_dump($category_id2);
//    print_r( $cache_w );
    
    foreach ( $cache_w as $ym => $cache_ym ){
        foreach ( $cache_ym as $c=> $cache_ymc ){
            usort_rec_int ( $cache_w[$ym][$c], 0 );
        }
    }
//    echo '<pre>';
//    print_r( $cache_w );
    foreach ( $cache_w as $ym => $cache_ym ){
        foreach ( $cache_ym as $c=> $cache_ymc ){
            $cache[$ym][$c] = array();
            foreach ( $cache_ymc as $k => $cache_ymck ){
                $cache[$ym][$c][$k] = $cache_ymck[1];
            }
        }
    }
//    echo '<pre>';
//    print_r($cache);
//    exit;    

    foreach ( $cache as $ym => $cache_ym ){
        @mkdir (  GT_DATA_DIR . 'cache/' . $ym );
        foreach ( $cache_ym as $c=> $cache_ymc ){
            $ret = update_csv_data( GT_DATA_DIR . 'cache/' . $ym . '/' . $c . '.php' , $cache_ymc );
            if ( !$ret ) return $ret;
        }
    }
    
    // 手抜き、常に更新
    $ret = update_csv_data( GT_DATA_DIR . 'cache_s/draft.php', $cache_w_d);
    if ( !$ret ) return $ret;

    read_cache('dummy','dummy',true);
    return true;
}
function cache_previous_next_month( $month ){

    $dir_list = gt_scandir( GT_DATA_DIR . 'cache/' );

    $this_month_key = array_search($month, $dir_list );

    for( $i=1; isset($dir_list[$this_month_key+$i]); $i++){
        if ( count(read_cache( 'all', $dir_list[$this_month_key+$i])) > 0 ){
            $next_month =  $dir_list[$this_month_key+$i];
            break;
        }
    }
    for( $i=1; isset($dir_list[$this_month_key-$i]); $i++){
        if ( count(read_cache( 'all', $dir_list[$this_month_key-$i])) > 0 ){
            $previous_month = $dir_list[$this_month_key-$i];
            break;
        }
    }
    return array ( $previous_month, $next_month );
}

function read_cache( $category_id = 'all', $month = 'all', $reset = false ){
    static $cache;
    static $is_called = array();
    if ( $reset ){
        $is_called = array();
        return true;
    }

    if ( $is_called[$category_id][$month] ){
        return $cache[$category_id][$month];
    }
    if ( $category_id !== 'all' ){
        $categories = master_category($category_id);
        if ( !isset($categories[$category_id]) ){
            return array();
        }
    }
    
    if ( $month === 'all' ){
        $dir_list = gt_scandir( GT_DATA_DIR . 'cache/' );
    } else {
        if ( file_exists(  GT_DATA_DIR . 'cache/' . $month ) ) $dir_list[] = $month;
        else return array();
    }
//    print_r($dir_list);

    $cache_w = array();
    foreach ( $dir_list as $dir ){
        $ww = get_csv_data( GT_DATA_DIR . 'cache/' . $dir . '/' . $category_id . '.php' , false );
        if ( $ww !== '' ) $cache_w[$dir] = $ww;
//        if ( $ww ) $cache_w[$dir] = $ww;
    }
//    echo '<pre>';
//    print_r( $cache_w );

    $cache_w2 = array();
    foreach ( $cache_w as $ww ){
        $cache_w2 = array_merge($cache_w2, $ww );
    }
//    var_dump( $cache_w2 );

    foreach ( $cache_w2 as $k => $v ) $cache_w2[$k] = (int) $v;
//    var_dump( $cache_w2 );

    $is_called[$category_id][$month] = true;
    $cache[$category_id][$month] = $cache_w2;
    return $cache[$category_id][$month];
        
}

function read_cache_draft() {
    $ww = get_csv_data( GT_DATA_DIR . 'cache_s/draft.php' );
    return $ww;
}
/* エントリ、コメント、複合操作関数群 */
function get_entry_all( $entry_id, $log_error = true ){
    $record = get_entry( $entry_id, $log_error );
    if (!$record) return false;
    $record['comment'] = list_comment_in_entry( $entry_id );
    $record['trackback'] = list_trackback_in_entry( $entry_id );
    return $record;
}
function list_entry_all( $log_error = true ){
    $entry_array = list_entry( $log_error );
    foreach ( $entry_array as $entry_id => $entry_record ){
	$entry_array[$entry_id]['comment'] =
		list_comment_in_entry($entry_id);
	$entry_array[$entry_id]['trackback'] =
		list_trackback_in_entry($entry_id);
    }
    return $entry_array;
}

/* エントリ（単独）操作関数群 */
function insert_entry( $record, &$entry_id ){
    return insert_data( 'entry', $record, $entry_id );
}
function get_entry( $entry_id, $log_error = true ){
    return get_data('entry', $entry_id, $log_error);
}
function check_entry( $entry_id ){
    return check_data('entry', $entry_id );
}
function update_entry( $record, $entry_id ){
    return update_data( 'entry', $record, $entry_id );
}
function delete_entry( $entry_id ){
    return delete_data('entry', $entry_id);
}
function list_entry(){
    return list_data('entry');
}
function get_last_entry_number(){
    return get_last_data_number('entry');
}
/* コメント操作関数群 */
function get_comment( $comment_id, $log_error = true ){
    return get_data('comment', $comment_id, $log_error);
}
function list_comment_in_entry( $entry_id ){
    $entry_to_comment_record = get_data( 'entry_comment', $entry_id, false );
//    print_r($entry_to_comment_record);
    $ret_list = array();
    if ( !$entry_to_comment_record ) return array();
    foreach ( $entry_to_comment_record as $c => $dummy ){
        $ret_list[$c] = get_comment($c);
    }
    return $ret_list;
}
function insert_comment( $entry_id, $record, &$comment_id ){
    $ret = get_data( 'entry', $entry_id );
    if ( !$ret ) return false;
    $record['entry_id'] = $entry_id;
    $ret = insert_data( 'comment', $record, $comment_id );
    if ( !$ret ) return false;
    $entry_to_comment_record = get_data( 'entry_comment', $entry_id, $false );
    $entry_to_comment_record[$comment_id] = true;
    $ret = update_data( 'entry_comment', $entry_to_comment_record, $entry_id );
    return $ret;
}
function update_comment( $comment_id, $record ){
    $ret = update_data( 'comment', $record, $comment_id );
    return $ret;
}
function delete_comment( $comment_id ){
    $comment_record = get_comment( $comment_id );
    if ( !$comment_record ) return false;
    $entry_to_comment_record = get_data( 'entry_comment', $comment_record['entry_id'] );
    if ( isset($entry_to_comment_record[$comment_id] ) ){ 
        unset ( $entry_to_comment_record[$comment_id] );
        $ret = update_data( 'entry_comment', $entry_to_comment_record, $comment_record['entry_id'] );
        if (!$ret ) return false;
    } else {
        user_error("ＤＢ整合性エラー。comment_id = $comment_id"); 
    }
    $ret = delete_data( 'comment', $comment_id );
    return $ret;
}
function get_last_comment_number(){
    return get_last_data_number('comment');
}
/* トラックバック操作関数群 */
function get_trackback( $trackback_id, $log_error = true ){
    return get_data('trackback', $trackback_id, $log_error);
}
function list_trackback_in_entry( $entry_id ){
    $entry_to_trackback_record = get_data( 'entry_trackback', $entry_id, false );
//    print_r($entry_to_trackback_record);
    $ret_list = array();
    if ( !$entry_to_trackback_record ) return array();
    foreach ( $entry_to_trackback_record as $c => $dummy ){
        $ret_list[$c] = get_trackback($c);
    }
    return $ret_list;
}
function insert_trackback( $entry_id, $record, &$trackback_id ){
    $ret = get_data( 'entry', $entry_id );
    if ( !$ret ) return false;
    $record['entry_id'] = $entry_id;
    $ret = insert_data( 'trackback', $record, $trackback_id );
    if ( !$ret ) return false;
    $entry_to_trackback_record = get_data( 'entry_trackback', $entry_id, $false );
    $entry_to_trackback_record[$trackback_id] = true;
    $ret = update_data( 'entry_trackback', $entry_to_trackback_record, $entry_id );
    return $ret;
}
function update_trackback( $trackback_id, $record ){
    $ret = update_data( 'trackback', $record, $trackback_id );
    return $ret;
}
function delete_trackback( $trackback_id ){
    $trackback_record = get_trackback( $trackback_id );
    if ( !$trackback_record ) return false;
    $entry_to_trackback_record = get_data( 'entry_trackback', $trackback_record['entry_id'] );
    if ( isset($entry_to_trackback_record[$trackback_id] ) ){ 
        unset ( $entry_to_trackback_record[$trackback_id] );
        $ret = update_data( 'entry_trackback', $entry_to_trackback_record, $trackback_record['entry_id'] );
        if (!$ret ) return false;
    } else {
        user_error("ＤＢ整合性エラー。trackback_id = $trackback_id"); 
    }
    $ret = delete_data( 'trackback', $trackback_id );
    return $ret;
}
function get_last_trackback_number(){
    return get_last_data_number('trackback');
}
/* 汎用シリアルデータ操作 */
function get_data($prefix, $entry_id, $log_error = true ){
    $filename = data_number_to_filename($prefix, $entry_id);
    return get_serial_data( $filename, $log_error );
}
function check_data($prefix, $entry_id ){
    $filename = data_number_to_filename($prefix, $entry_id);
    return file_exists( $filename );
}
function insert_data( $prefix, $record, &$id ){
    $n = get_last_data_number($prefix);
    $n++;
    $ret = insert_data_with_id ( $prefix, $record, $n );
    if ( !$ret ) return false;
    $id = $n;
    return true;
}
function insert_data_with_id( $prefix, $record, $id ){
    $n = $id;
    $dirname = data_number_to_dirname($prefix, $n);
    $filename = data_number_to_filename($prefix, $n);
    @mkdir($dirname);
    $ret = put_serial_data( $filename, $record );
    return $ret;
}
function update_data( $prefix, $record, $id ){
    $dirname = data_number_to_dirname($prefix, $id);
    @mkdir( $dirname );
    $filename = data_number_to_filename($prefix, $id);
    return update_serial_data( $filename, $record );
}
function delete_data( $prefix, $id ){
    $filename = data_number_to_filename($prefix, $id);
    return delete_serial_data( $filename );
}
function list_data($prefix){
    $list = array();
    $data_root_files = gt_scandir ( GT_DATA_DIR . $prefix, 0 );
    foreach ( $data_root_files as $v ){
        $data_files = gt_scandir ( GT_DATA_DIR . $prefix . '/' . $v, 0 );
        foreach ( $data_files as $f ){
            $list[file_name_to_data_number($f)] =
                get_serial_data( GT_DATA_DIR . $prefix .'/' . $v . '/' . $f );
        }
    }
    return $list;
}
function get_last_data_number($prefix){
    $data_root_files = gt_scandir ( GT_DATA_DIR . $prefix, 1 );
    foreach ( $data_root_files as $v ){
        $data_files = gt_scandir ( GT_DATA_DIR . $prefix . '/' . $v, 1 );
        foreach ( $data_files as $f ){
            return file_name_to_data_number( $f );
        }
    }
    return 0;
//    return -1;
}

define ( GT_WIDTH, 100 );

function data_number_to_filename($prefix,$n){
    $dir_number = $n/GT_WIDTH;
    return GT_DATA_DIR . sprintf( $prefix . '/%03d/%05d.php', $dir_number, $n ); 
}
function data_number_to_dirname($prefix,$n){
    $dir_number = $n/GT_WIDTH;
    return GT_DATA_DIR . sprintf( $prefix . '/%03d/', $dir_number );
}
function file_name_to_data_number($f){
    return  (int) substr($f,0,5);
}
function get_serial_data( $filename, $log_error = true ){
    if ( $log_error ) $file_data = file_get_contents($filename);
//    if ( $log_error ) $file_data = @file_get_contents($filename);
    else $file_data = @file_get_contents($filename );
    if ( !$file_data ) return false;
    $serial_data = substr( $file_data, strlen(GT_SERIAL_HEADER));
    return unserialize( $serial_data );
}
function update_serial_data( $filename, $params ){
    $serial_data = serialize( $params );
    /* wなので、もしファイルが存在しなければ、作成する */
    $fp = fopen( $filename, 'w' );
    if ( !$fp ) return false;
    $file_data = GT_SERIAL_HEADER . $serial_data;
    $status = fwrite ( $fp, $file_data );
    if ( !$status ) return false;
    fclose ( $fp );
    return true;
}
function put_serial_data( $filename, $params ){
    $serial_data = serialize( $params );
    /* xなので、ファイルが既に存在することが前提 */
    $fp = fopen( $filename, 'x' );
    if ( !$fp ) return false;
    $file_data = GT_SERIAL_HEADER . $serial_data;
    $status = fwrite ( $fp, $file_data );
    if ( !$status ) return false;
    fclose ( $fp );
    return true;
}
function delete_serial_data( $filename ){
    return unlink( $filename );
}

function get_csv_data( $filename, $log_error = true ){
    if ( $log_error ) $file_data = file_get_contents($filename);
    else $file_data = @file_get_contents($filename );
    if ( !$file_data ) return array();
    $csv_data = substr( $file_data, strlen(GT_SERIAL_HEADER));
    if ( $csv_data == '' ) return array();
    return explode(',', $csv_data );
}
function update_csv_data( $filename, $params ){
    $csv_data = implode( ',', $params );
    /* wなので、もしファイルが存在しなければ、作成する */
    $fp = fopen( $filename, 'w' );
    if ( !$fp ) return false;
    $file_data = GT_SERIAL_HEADER . $csv_data;
    $status = fwrite ( $fp, $file_data );
    if ( !$status ) return false;
    fclose ( $fp );
    return true;
}
function put_csv_data( $filename, $params ){
    $csv_data = implode( ',', $params );
    /* xなので、ファイルが既に存在することが前提 */
    $fp = fopen( $filename, 'x' );
    if ( !$fp ) return false;
    $file_data = GT_SERIAL_HEADER . $csv_data;
    $status = fwrite ( $fp, $file_data );
    if ( !$status ) return false;
    fclose ( $fp );
    return true;
}
function delete_csv_data( $filename ){
    return unlink( $filename );
}


function get_s_data( $filename, $log_error = true ){
    if ( $log_error ) $file_data = file_get_contents($filename);
    else $file_data = @file_get_contents($filename );
    if ( !$file_data ) return false;
    $out_data = substr( $file_data, strlen(GT_SERIAL_HEADER));
    return $out_data;
}
function update_s_data( $filename, $params ){
    /* wなので、もしファイルが存在しなければ、作成する */
    $fp = fopen( $filename, 'w' );
    if ( !$fp ) return false;
    $file_data = GT_SERIAL_HEADER . $params;
    $status = fwrite ( $fp, $file_data );
    if ( !$status ) return false;
    fclose ( $fp );
    return true;
}
function put_s_data( $filename, $params ){
    /* xなので、ファイルが既に存在することが前提 */
    $fp = fopen( $filename, 'x' );
    if ( !$fp ) return false;
    $file_data = GT_SERIAL_HEADER . $params;
    $status = fwrite ( $fp, $file_data );
    if ( !$status ) return false;
    fclose ( $fp );
    return true;
}
function delete_s_data( $filename ){
    return @unlink( $filename );
}
function array_sjis_to_utf( &$item, $key ){
    $item = mb_convert_encoding( $item, 'UTF-8', 'SJIS' );
}
function array_specialchars( &$item, $key ){
    $item = htmlspecialchars( $item ); 
}
if (!function_exists('array_walk_recursive'))
{
   function array_walk_recursive(&$input, $funcname, $userdata = "")
   {
       if (!is_callable($funcname))
       {
           return false;
       }
      
       if (!is_array($input))
       {
           return false;
       }
      
       foreach ($input AS $key => $value)
       {
           if (is_array($input[$key]))
           {
               array_walk_recursive($input[$key], $funcname, $userdata);
           }
           else
           {
               $saved_value = $value;
               if (!empty($userdata))
               {
                   $funcname($value, $key, $userdata);
               }
               else
               {
                   $funcname($value, $key);
               }
              
               if ($value != $saved_value)
               {
                   $input[$key] = $value;
               }
           }
       }
       return true;
   }
}
function gt_scandir( $dir, $sort = 0)
{
  
   $dir_open = opendir($dir);
   if (! $dir_open) return false;
      
   $files = array();
   while (($dir_content = readdir($dir_open)) !== false) {
       if ( ctype_digit(str_replace('.php','',$dir_content) ) ) $files[] = $dir_content;
   }
   if ($sort == 1 )
       rsort($files, SORT_STRING);
   else
       sort($files, SORT_STRING);
  
   return $files;
}
function myscandir( $dir, $sort = 0)
{
  
   $dir_open = opendir($dir);
   if (! $dir_open) return false;
      
   $files = array();
   while (($dir_content = readdir($dir_open)) !== false) {
       if ( $dir_content !== '.' and $dir_content !== '..' ) $files[] = $dir_content;
   }
   if ($sort == 1 )
       rsort($files, SORT_STRING);
   else
       sort($files, SORT_STRING);
  
   return $files;
}
/* クライアント種別取得関数 */
function which_view(){
//return 'mobile_view';
    $ua = $_SERVER["HTTP_USER_AGENT"];
    if ( strpos($ua, 'DoCoMo' ) === false and
         strpos($ua, 'Up.Browser' ) === false and
         strpos($ua, 'J-PHONE' ) === false ){
        return 'pc_view';
    } else {
        return 'mobile_view';
    }
}

function convert_input_tag( $input ){
    $retstring = preg_replace_callback( '/\[[^\]]*\]/', convert_input_tag_callfunc,  $input);
    return $retstring;
}
function convert_input_tag_callfunc($matches){
//    print_r($matches);
    $in_tag = substr( $matches[0], 1, strlen($matches[0])-2);
//    echo $in_tag;
    $array_in_tag = explode( ':', $in_tag );
    switch ( $array_in_tag[0] ){
        case 'image':
            $ret_string = image_tag_to_html_tag( $array_in_tag );
            break;
        case 'icon';
            $ret_string = icon_tag_to_html_tag( $array_in_tag );
            break;
        default:
	    $ret_string = $matches[0];
    }
    return $ret_string;
}
function image_tag_to_html_tag( $array_in_tag ){
    $master_upload = master_upload();
    $image_file_base = $array_in_tag[1];
    $image_align = $array_in_tag[2];
    $image_alt = $array_in_tag[3];
    if ( which_view() == 'pc_view' ){
        $fl_s = glob( $master_upload['standard']['path'] . '/' . $image_file_base . '.*');
        $fl_p = glob( $master_upload['popup']['path'] . '/' . $image_file_base . '.*');

        list($width, $height, $type, $attr) = getimagesize($fl_s[0]);
        if ( $image_align ) $t_align = "align=\"$image_align\"";
        else $t_align = "";
        $image_tag = "<img src=\"$fl_s[0]\" width=\"$width\" height=\"$height\" $t_align alt=\"$image_alt\">";
        if ( $fl_p ){
            $image_tag = "<a href=\"$fl_p[0]\" target=\"_blank\">" . $image_tag . "</a>";
        } else {
        }
        return $image_tag;
    } else {
        $fl_t = glob( $master_upload['thumbnail']['path'] . '/' . $image_file_base . '.*');

        list($width, $height, $type, $attr) = getimagesize($fl_t[0]);
        if ( $image_align ) $t_align = "align=\"$image_align\"";
        else $t_align = "";
        $image_tag = "<img src=\"$fl_t[0]\" width=\"$width\" height=\"$height\" $t_align alt=\"$image_alt\">";

        return $image_tag;
    }
}
function icon_tag_to_html_tag( $array_in_tag ){
    $master_blog = master_blog();
    $image_file = $array_in_tag[1];

        $fl_t[0] = $master_blog['icondir'] . '/' . $image_file;

        list($width, $height, $type, $attr) = getimagesize($fl_t[0]);
        $image_tag = "<img src=\"$fl_t[0]\" width=\"$width\" height=\"$height\">";

        return $image_tag;
}

/* ソート用汎用関数 */
/* レコードソート用usort、数値比較 */
function usort_rec_int( &$array, $column ){
    $compfunc = create_function( '$a,$b', 'return $a[' . $column . ']-$b[' . $column . '];');
    usort( &$array, $compfunc );
}
function deleteDir($dir)
{
   if (substr($dir, strlen($dir)-1, 1) != '/')
       $dir .= '/';

   if ($handle = opendir($dir))
   {
       while ($obj = readdir($handle))
       {
           if ($obj != '.' && $obj != '..')
           {
               if (is_dir($dir.$obj))
               {
                   if (!deleteDir($dir.$obj))
                       return false;
               }
               elseif (is_file($dir.$obj))
               {
                   if (!unlink($dir.$obj))
                       return false;
               }
           }
       }

       closedir($handle);

       if (!@rmdir($dir))
           return false;
       return true;
   }
   return false;
}
function performance( $func='show' ){
    static $init_time;
    if ( $func == 'init' ){
        $w = microtime();
        $w2 = explode( ' ', $w );
        $init_time = $w2[0] + $w2[1];
        return true;
    } else {
        $w = microtime();
        $w2 = explode( ' ', $w );
        $now_time = $w2[0] + $w2[1];
        $d= $now_time - $init_time;
        if ( $d < 0.001 ) $d=round($d,6);
        else $d=round($d,3);
        return $d;
    }
}
function return_bytes($val) {
   $val = trim($val);
   $last = strtolower($val{strlen($val)-1});
   switch($last) {
       // 'G' は、PHP 5.1.0 より有効となる
       case 'g':
           $val *= 1024;
       case 'm':
           $val *= 1024;
       case 'k':
           $val *= 1024;
   }

   return $val;
}
function check_url( $url ){
    $ret = preg_match("@^(http|https|ftp)://[a-z0-9\.\-\@:\x80-\xFD]*?/.*@i", $url );
    return $ret;

}

/* トラックバック、キーのハッシュ */
define( "TB_TIMELIMIT_UNIT",1);
define( "TB_TIMELIMIT_NUM",600);

function md5_trackback_key_generate( $entry_id, $time, &$time_k ){
    $master_trackback = master_trackback();
//    echo $time;echo "\n";
    $time_base = (int) floor($time / TB_TIMELIMIT_UNIT);
    $s = $master_trackback['timelimit_trackback_seed'] . '/' . $entry_id . '/' . $time_base;
//    echo $s;echo "\n";
//    echo md5($s);echo "\n";
    $time_k = $time_base * TB_TIMELIMIT_UNIT;
    return md5($s);
}

/* ブックマーク自動ログイン ハッシュ */
function md5_autologin_param( $user_id, $password, $seed ){
//echo  $user_id . '/' . $password . '/' . $seed;
    return md5( $user_id . '/' . $password . '/' . $seed );
}
/* tempのガーベッジコレクション */
function gt_gc(){
    $rand = rand(1, GT_GC_DIVISOR );
//    echo $rand;
//    echo GT_GC_LIFETIME;
    if ( $rand > 1 ) return;
    $file_list = myscandir( GT_DATA_DIR . 'temp/');
//    print_r($file_list);
    $now = time();
    foreach ( $file_list as $f ){
        $f_full =  GT_DATA_DIR . 'temp/' . $f;
        $mtime = filemtime(  $f_full );
//        echo $f . "*";echo $mtime . "*" .($now-$mtime);echo "\r\n";
        if ( $now - $mtime > GT_GC_LIFETIME ){
            unlink($f_full);
//            echo $f ."delete\n";
        }
    }
}
?>
