<?php
/*
    エントリーを登録して、リダイレクトしexitする。
    入力エラーも含め、エラーの場合には、テンプレート変数を割り当て、リターンする
*/
function do_new_entry( &$smarty ){


    /* デフォルト値のセット */
    $default['allow_comments'] = true;
    $default['allow_pings'] = true;
    require_once('login_func.php');
    $gb_login_info = gb_login_info();
    $default['user_id'] = $gb_login_info['id'];
    $smarty->assign('s', $default );
    return true;

}
function do_get_entry( &$smarty ){

    $entry_data = get_entry( $_REQUEST['entry']);
    if (!$entry_data ){
        user_error('エントリー参照に失敗しました',E_USER_WARNING);
        exit;
    }
    $smarty->assign('s', $entry_data );
    return true;

}
function do_insert_entry( &$smarty ){

    $request = filter_request( $_REQUEST['s'] );
    $ret_input_check = check_convert_requested_data( $request, 
	    $output, $display, $errors );
    if ( !$ret_input_check ){
        $smarty->assign('s', $display );
        $smarty->assign('errors', $errors );
        return false;
    }

    $ret = insert_entry( $output, $entry_number);
    if (!$ret ){
        user_error('エントリー作成に失敗しました',E_USER_WARNING);
        exit;
    }
//    echo '<pre>end insert entry';
//    print_r($output);

    update_data_and_smarty_cache( $smarty, $entry_number, false, $output );

    header("Location: index.php?e=$entry_number");
    exit;
}

function do_update_entry( &$smarty ){

    $entry_number = $_REQUEST['entry'];
    $request = filter_request( $_REQUEST['s'] );
    $ret_input_check = check_convert_requested_data( $request, 
	    $output, $display, $errors );
    if ( !$ret_input_check ){
        $smarty->assign('s', $display );
        $smarty->assign('errors', $errors );
        return false;
    }

    $original = get_entry( $entry_number );
    if ( !$original ) {
        user_error('エントリー更新時参照に失敗しました',E_USER_WARNING);
        exit;
    }
    // 今のところ、日付更新機能はないので、、、
    $output['date'] = $original['date'];

    $ret = update_entry( $output, $entry_number);
    if (!$ret ){
        user_error('エントリー更新に失敗しました',E_USER_WARNING);
        exit;
    }
//    echo '<pre>end update entry';
//    print_r($original);
    update_data_and_smarty_cache( $smarty, $entry_number, $original, $output );

    header("Location: index.php?e=$entry_number");
    exit;

}
function do_delete_entry( &$smarty ){

    $entry_number = $_REQUEST['entry'];

    $original = get_entry( $entry_number );
    if ( !$original ) {
        user_error('エントリー削除時参照に失敗しました',E_USER_WARNING);
        exit;
    }
    
    $ret = delete_entry( $entry_number);
    if (!$ret ){
        user_error('エントリー削除に失敗しました',E_USER_WARNING);
        exit;
    }

//    echo '<pre>end delete entry';
//    print_r($original);
    
    update_data_and_smarty_cache( $smarty, $entry_number, $original, false );

    header("Location: index.php?e=$entry_number");
    exit;

}
function update_data_and_smarty_cache( &$smarty, $entry_number, $oldrec, $newrec ){

    $month_old = strftime( '%Y%m', $oldrec['date'] );
    $month_new = strftime( '%Y%m', $newrec['date'] );

    $count_all_before = count(read_cache('all'));
    $count_category_old_before = count(read_cache($oldrec['category_id'] ));
    $count_category_new_before = count(read_cache($newrec['category_id'] ));
    $count_month_old_before = count(read_cache('all', $month_old ));
    $count_month_old_before = count(read_cache('all', $month_new ));

    //キャッシュクリアリスト作成、キャッシュ更新前
    // ページ、エントリ、月別、エントリナビ
    if ( $oldrec ){
        $del_smarty_cache_list['pre'] = list_update_smarty_cache_pre( 
            $entry_number, $oldrec['date'], $newrec['date'], 
            $oldrec['status'], $newrec['status'], $oldrec['category_id'], $newrec['category_id']);
    }
    
    if ( $newrec and $oldrec ) {
      if (
         $oldrec['date'] == $newrec['date'] or
         $oldrec['status'] == $newrec['status'] or
         $oldrec['category_id'] == $newrec['category_id']
         ) {
        $ret = update_cache( $oldrec['date'], $oldrec['category_id'] );
          if (!$ret ) {
            user_error('キャッシュ更新に失敗しました',E_USER_WARNING);
            exit;
          }
      }
    } else {
      if ( $oldrec ){
        $ret = update_cache( $oldrec['date'], $oldrec['category_id'] );
        if (!$ret ) {
            user_error('キャッシュ更新に失敗しました',E_USER_WARNING);
            exit;
        }
      }
      if ( $newrec ){
        $ret = update_cache( $newrec['date'], $newrec['category_id'] );
        if (!$ret ) {
            user_error('キャッシュ更新に失敗しました',E_USER_WARNING);
            exit;
        }
      }
    }

    $count_all_after = count(read_cache('all'));
    $count_category_old_after = count(read_cache($oldrec['category_id'] ));
    $count_category_new_after = count(read_cache($newrec['category_id'] ));
    $count_month_old_after = count (read_cache('all', $month_old ));
    $count_month_old_after = count (read_cache('all', $month_new ));
        

    //キャッシュクリアリスト作成、キャッシュ更新後
    // ページ、エントリ、月別、エントリナビ
    if ( $newrec ){

        $del_smarty_cache_list['post'] = list_update_smarty_cache_post( 
            $entry_number, $oldrec['date'], $newrec['date'], 
            $oldrec['status'], $newrec['status'], $oldrec['category_id'], $newrec['category_id']);

    }
    //月別ナビ
    if ( $count_month_old_before > 0 xor $count_month_old_after > 0 ){
        list( $v1, $v2 ) = cache_previous_next_month( $month_new );
        if ( $v1 ) $del_smarty_cache_list['mnavi_old'][] = 'month_navi|' . $v1;
        if ( $v2 ) $del_smarty_cache_list['mnavi_old'][] = 'month_navi|' . $v2;
    }
    if ( $count_month_new_before > 0 xor $count_month_new_after > 0 ){
        list( $v1, $v2 ) = cache_previous_next_month( $month_new );
        if ( $v1 ) $del_smarty_cache_list['mnavi_new'][] = 'month_navi|' . $v1;
        if ( $v2 ) $del_smarty_cache_list['mnavi_new'][] = 'month_navi|' . $v2;
    }
    //ページナビ
  foreach ( array('pc_view','mobile_view') as $view ){
    if ( count_to_last_page_number( $count_all_before, $view ) <> 
         count_to_last_page_number( $count_all_after, $view ) ) {
        $del_smarty_cache_list['pnavi_all'][] = 'page_navi|all';
    }
    if ( count_to_last_page_number( $count_category_new_before, $view ) <> 
         count_to_last_page_number( $count_category_new_after, $view ) ) {
        $del_smarty_cache_list['pnavi_c_new'][] = 'page_navi|' . $newrec['category_id'];
    }
    if ( count_to_last_page_number( $count_category_old_before, $view ) <> 
         count_to_last_page_number( $count_category_old_after, $view ) ) {
        $del_smarty_cache_list['pnavi_c_old'][] = 'page_navi|' . $newrec['category_id'];
    }
  }
    //最近のエントリ
    $del_smarty_cache_list['recent_entries'][] = 'recent_entries';
    //RSS
    $del_smarty_cache_list['rss'][] = 'rss';
//print_r( $del_smarty_cache_list );
    foreach ( $del_smarty_cache_list as $v ){
        foreach ( $v as $vv ){
            $smarty->clear_cache(null, $vv );
        }
    }
}

function do_preview_entry( &$smarty ){
//phpinfo();
    $request = filter_request( $_REQUEST['s'] );
    $ret_input_check = check_convert_requested_data( $request, 
	    $output, $display, $errors );
    $smarty->assign('errors', $errors);
    $smarty->assign('s', $display );
    return;
}

function check_convert_requested_data( $input, &$output, &$display, &$errors ){

    
    $ret = true;
    $display = $input;

    array_walk_recursive( $display, 'array_specialchars' );    

    $master_category = master_category();
    $master_status = master_status();
    $master_user = master_user();
    require_once('login_func.php');
    $gb_login_info = gb_login_info();


    $d_uid = $input['user_id'];

    $display['user_id'] = $d_uid;
    $display['category_name'] = $master_category[$input['category_id']]['name'];
    $display['user_name'] = $master_user[$d_uid]['name'];


    $w_preview =  nl2br($input['introduction']). '<br />' . nl2br($input['body']);
    $w_preview = convert_input_tag( $w_preview );
    $display['preview'] = $w_preview;
    
    if ( !isset( $master_category[$input['category_id']] ) ){
        $errors[] = '登録されていないカテゴリが指定されました。';
        $ret = false;
    }
    if ( $input['title'] == '' ) {
        $errors[] = 'タイトルは、必ず指定してください。';
        $ret = false;
    }
    if ( $input['introduction'] == '' ) {
        $errors[] = 'イントロダクションは、必ず指定してください。';
        $ret = false;
    }
    if ( !isset( $master_status[$input['status']] ) ) {
        $errors[] = '存在しないステータスが指定されました。';
        $ret = false;
    }


    $output['user_id'] = $d_uid;
    $output['title'] = $input['title'];
    $output['category_id'] = $input['category_id'];
    $output['date'] = mktime();
    
    $output['status'] = $input['status'];
    $output['nl2br'] = true;
    $output['allow_comments'] = (bool) $input['allow_comments'];
    $output['allow_pings'] = (bool) $input['allow_pings'];
    
    $output['introduction'] = $input['introduction'];

    $output['body'] = $input['body'];

    return $ret;
}
?>