<?php
/*
    コメントを登録して、リダイレクトしexitする。
    入力エラーも含め、エラーの場合には、テンプレート変数を割り当て、リターンする
*/

// この関数は、管理者しか使わないので、エラー時は、メッセージも表示し落とす。
function do_get_trackback( &$smarty ){

    $entry_data = get_entry_all( $_REQUEST['entry']);
    translate_entry_for_display( $entry_data );

    if (!$entry_data ){
        user_error('エントリー参照に失敗しました',E_USER_WARNING);
        exit;
    }
    $trackback_data = $entry_data['trackback'][$_REQUEST['trackback']];
    if ( !$trackback_data ){
        user_error('該当エントリに該当トラックバックが存在しません。');
        exit;
    }



    $entry[$_REQUEST['entry']] = $entry_data;

    $smarty->assign('entry', $entry);
    
    //ＤＢが壊れてるとき等、こちらの値のほうが手堅いために置き換える。
    $trackback_data['entry_id'] = $_REQUEST['entry'];

    $trackback_data['trackback_id'] = $_REQUEST['trackback'];
    $smarty->assign('tb', $trackback_data );

}

function do_update_trackback( &$smarty ){

    $entry_id = $_REQUEST['entry'];
    $trackback_id = $_REQUEST['trackback'];
    $entry_data = get_entry_all( $entry_id );
    translate_entry_for_display( $entry_data );
    if (!$entry_data ){
        user_error('エントリー参照に失敗しました',E_USER_WARNING);
        exit;
    }
    $trackback_data = $entry_data['trackback'][$trackback_id];
    if ( !$trackback_data ){
        user_error('該当エントリに該当トラックバックが存在しません。');
        exit;
    }

    $request = filter_request( $_REQUEST['tb'] );

    $ret_input_check = check_convert_requested_data( $request, 
	    $output, $display, $errors );

    $entry_rec = get_entry_all( $entry_id );
    translate_entry_for_display( $entry_rec );

    $entry[$entry_id] = $entry_rec;
    $smarty->assign('entry', $entry);
    
    $display['entry_id'] = $entry_id;
    $display['trackback_id'] = $trackback_id;
    if ( !$ret_input_check ){ 
        $smarty->assign('tb', $display );
        $smarty->assign('trackback_errors', $errors );
        return false;
    }

    $output['date'] = $trackback_data['date'];
    $output['ip'] = $trackback_data['ip'];
    $output['host'] = $trackback_data['host'];
    $output['entry_id'] = $trackback_data['entry_id'];
    $output['user_agent'] = $trackback_data['user_agent'];
    $output['accept_language'] = $trackback_data['accept_language'];

    $ret = update_trackback( $trackback_id, $output );
    if (!$ret ){
        user_error('トラックバック更新に失敗しました',E_USER_WARNING);
        exit;
    }
    $del_smarty_cache = list_trackback_update_smarty_cache( $entry_id );

//    echo '<pre>';
//    print_r( $del_smarty_cache );

    foreach ( $del_smarty_cache as $v){
        $smarty->clear_cache(null, $v );
    }
    

    header("Location: index.php?e=$entry_id#trackback$trackback_id");
    exit;
}



function do_delete_trackback( &$smarty ){

    $entry_id = $_REQUEST['entry'];
    $trackback_id = $_REQUEST['trackback'];

    //print_r( $_REQUEST );

    $entry_data = get_entry_all( $entry_id );
    translate_entry_for_display( $entry_data );
//    print_r( $entry_data);
    if (!$entry_data ){
        user_error('エントリー参照に失敗しました',E_USER_WARNING);
        exit;
    }
    $trackback_data = $entry_data['trackback'][$trackback_id];
    if ( !$trackback_data ){
        user_error('該当エントリに該当コメントが存在しません。');
        exit;
    }

    $ret = delete_trackback( $trackback_id );
    if (!$ret ){
        user_error('トラックバック削除に失敗しました',E_USER_WARNING);
        exit;
    }

//    echo '<pre>end delete entry';
//    print_r($original);
    $del_smarty_cache = list_trackback_smarty_cache( $entry_id, $entry_data['category_id'] );

//    echo '<pre>';
//    print_r( $del_smarty_cache );

    foreach ( $del_smarty_cache as $v){
        $smarty->clear_cache(null, $v );
    }
    header("Location: index.php?e=$entry_id#trackback");
    exit;

}

function check_convert_requested_data( $input, &$output, &$display, &$errors ){

    
    $ret = true;
    $display = $input;

    array_walk_recursive( $display, 'array_specialchars' );    

//    $master_category = master_category();
//    $master_status = master_status();
//    $master_user = master_user();

    if ( trim($input['url']) == '' ) {
        $errors[] = 'URLは、必ず指定してください。';
        $ret = false;
    }
    if ( trim($input['url']) !== '' and !check_url(trim($input['url']))){
        $errors[] = 'URLに間違いがあります。';
        $ret = false;
    }

    $output['title'] = trim($input['title']);
    $output['body'] = trim($input['body']);
    $output['url'] = trim($input['url']);
    $output['blog_name'] = $input['blog_name'];
    $output['date'] = mktime();
    $output['ip'] = $_SERVER["REMOTE_ADDR"];
    $output['host'] = gethostbyaddr($_SERVER["REMOTE_ADDR"]);
    $output['user_agent'] = $_SERVER["HTTP_USER_AGENT"];
    $output['accept_language'] = $_SERVER["HTTP_ACCEPT_LANGUAGE"];

    
    $output['entry_id'] = $input['entry_id'];

    return $ret;
}
?>