<?php

require_once('pop3-class.php');
require_once('image_func.php');

function moblog(){
    $master_user = master_user();
//    echo '<pre>';
//    print_r($master_user);
    foreach ( $master_user as $k => $v ){
        if ( !$v['moblog']['pop_host'] ) continue;
        $check_moblog_file = GT_DATA_DIR . 'moblog/check_' . $k . '.php';
        $last_checked_time = get_serial_data( $check_moblog_file, false );
        $now = time();
        $sa = $now - $last_checked_time;
//        echo '**'.$sa.'**';
        if ( $sa > $v['moblog']['pop_access_interval'] * 60 ){
            $ret = moblog_do( $k, $v['moblog'] );
            if ( !$ret ){
                user_error('moblog更新に失敗しました。');
                return false;
            }
            update_serial_data( $check_moblog_file, $now );
        }
    }
}
function moblog_do($user_id, $moblog_attr ){
/*
echo '**************';
print_r($user_id);
print_r($moblog_attr);
*/
    $pop = new pop3( $moblog_attr['pop_host'], $moblog_attr['pop_username'],
        $moblog_attr['pop_password']);
    $ret = $pop->open();
    if (!$ret) {
        user_error('POP認証に失敗しました。');
        return false;
    }
    $list = $pop->get_list();
//    var_dump($ret);
    foreach ( $list as $k => $v ){
        $message = $pop->retr($k);
        list( $header, $body ) = explode("\r\n\r\n", $message, 2 ); 
//        echo '****header*'.$header.'*****';
        
        $mh = parse_main_header( $header );
        if ( strpos($mh['From'], $moblog_attr['from_mail_address'] ) === false ) continue;
//        print_r($mh);
//        echo '****body*'.$body.'****';
        $content = decode_content( $mh['Content-Type'], $mh['Content-Transfer-Encoding'], $body );
//        echo '******content**************************************************';
//        print_r($content);
//        echo '*************fl***********';
        $content_flat = new recursive_to_flat($content);
//        print_r( $content_flat );
//        echo '************************:content_end************';

       
        $introduction = '';
        
        foreach ( $content_flat->flat_data as $v ){
            if ( isset($v['text']) ){
                $introduction = $introduction . $v['text'];
            } elseif ( isset($v['image']) ){
                $tmpf = tempnam(GT_DATA_DIR . '/tmp', 'moblogimage_');
                if (!$tmpf) return false;
                $fp = fopen($tmpf, "w");
                fwrite($fp, $v['image']);
                fclose($fp);
                
                $ret = image_read( $retim, $tmpf, $o_im, $errors );
                if (!$ret ) {
//                    echo 'unsupported';
//                    print_r($retim);
                    $introduction = $introduction . implode("\r\n", $errors );

                }

                $ret = image_save( $tmpf, $v['name'], false, $retim, $o_im, $out_filename, $errors );
                if (!$ret ) {
                    return false;
                }
                $ret = unlink($tmpf);
                if (!$ret) return false;
                $introduction = '[image:' . $out_filename .  ':' . $moblog_attr['align'] .':]' . $introduction;
            }
        }
        $output['user_id'] = $user_id;
        $output['title'] = $mh['Subject'];
        $output['category_id'] = $moblog_attr['category_id'];
        $output['date'] = strtotime($mh['Date']);
    
        $output['status'] = 'Publish';
        $output['nl2br'] = true;
        $output['allow_comments'] = true;
        $output['allow_pings'] = true;
    
        $output['introduction'] = $introduction;

        $output['body'] = '';

        $ret = writelock();
        if (!$ret) return false;
        $ret = insert_entry( $output, $entry_number);
        if (!$ret ){
            user_error('moblogエントリ作成に失敗しました',E_USER_WARNING);
            exit;
        }
        require_once('do_entry.php');
        $smarty = new smarty_c;
        update_data_and_smarty_cache( $smarty, $entry_number, false, $output );
/*
        switch ( $mh['Content-Type-main'] ){
            case 'text/plain':
                break;
            case 'multipart/mixed':
                break;
        }
*/

        if ( !$pop->dele($k) ){
            user_error('メール削除失敗');
            return false;
        }

    }
    if ( !$pop->close() ){
        user_error('メールクローズ失敗');
        return false;
    }
    return true;

}
function decode_content( $ct, $ce, $body_arg ){
    list( $ct_type, $ct_subtype ) = explode('/', $ct[0],2);
    $ct_type = trim($ct_type);
    $ct_subtype = trim($ct_subtype);
    
    if ( $ct_type == 'multipart' ){
        $each_part = explode( '--' . $ct['boundary'] . "\r\n", $body_arg );
        foreach ( $each_part as $ep ){
            list( $each_header, $each_body ) = explode("\r\n\r\n", $ep, 2 );
            $eh = parse_each_header( $each_header );
//            print_r($eh);
            $each_content = decode_content( $eh['Content-Type'], $eh['Content-Transfer-Encoding'], $each_body );
            if ( $each_content ) $content[] = $each_content;
        }
    } elseif ( $ct_type == 'text' ){
        if ( $ct_subtype == 'plain' ){
            $content['text'] = convert_text_plain( $ct, $ce, $body_arg );
        }
    } elseif ( $ct_type == 'image' ){
        if ( $ce == 'base64' ){
            $content['name'] = $ct['name'];
            $content['image'] = base64_decode( $body_arg );
        }
    } elseif ( $ct_type == 'message' ){
//        echo '***********message********';
//        echo $body_arg;
//        echo '*************message_end';
        list( $header, $body ) = explode("\r\n\r\n", $body_arg, 2 );
        $eh = parse_each_header( $header );
        $content = decode_content( $eh['Content-Type'], $eh['Content-Transfer-Encoding'], $body);
        
    }
    return $content;
}

class recursive_to_flat{
    var $flat_data;
//    var $in_data;
    function recursive_to_flat( $arg_in_data ){
        $this->flat_data = array();
//        $this->in_data = $arg_in_data;
        $this->sub( $arg_in_data );
    }
    function sub( $arg ){
        foreach ( $arg as $k => $v ){
            if ( is_array($v) ){
                $this->sub($v);
            } else {
                $this->flat_data[] = $arg;
                break;
            }
        }
    }
}

function convert_text_plain( $ct, $ce, $text ){
//    var_dump($ce);
    if ( $ce == 'base64' ){
        $text_w = base64_decode( $text );
    } else {
        $text_w = $text;
    }
    if ( strtoupper($ct['charset']) == 'ISO-2022-JP' ){
        $text_r = mb_convert_encoding( $text_w, 'UTF-8', 'JIS' );
    } else {
        $text_r = mb_convert_encoding( $text_w, 'UTF-8', 'ASCII,JIS,UTF-8,EUC-JP,SJIS' ); 
    }
    return $text_r;
}
function parse_each_header( $header ){
    return parse_main_header( $header );
}
function parse_main_header( $header ){
    $h = parse_header_to_array( $header );
    foreach ( $h as $v ){
        list( $fn, $fv ) = explode(":",$v, 2 );
        switch ( $fn ){
            case ( "Subject" ):
                $r['Subject'] = mb_decode_mimeheader($fv);
                break;
            case ( "From" ):
                $r['From'] = $fv;
                break;
            case ( "Date" ):
                $r['Date'] = $fv;
                break;
            case ( "Content-Type" ):
                $ct_array = explode( ";", $fv );
                $r['Content-Type'][0] = trim($ct_array[0]);
                unset( $ct_array[0] );
                foreach( $ct_array as $v ){
                    $varray = explode( "=", $v, 2 );
                    $r['Content-Type'][trim($varray[0])] = unquote_and_trim($varray[1]);
                }
                break;
            case ( "Content-Transfer-Encoding" ):
                $r['Content-Transfer-Encoding'] = trim($fv);
                break;
        }
    }
    return $r;
}

function parse_header_to_array( $header ){
    $lines = explode("\r\n", $header );
    $h = array();
    $hn = -1;
    foreach ( $lines as $v ){
        if ( $v{0} == ' ' or $v{0} == "\t" ){
            $h[$hn] .= $v;
        } else {
            $hn++;
            $h[$hn] = $v;
        }
    }
    return $h;
}
function unquote_and_trim($s){
    $s=trim($s);
    if ( $s{0} == "\"" and $s{strlen($s)-1} ) return substr($s, 1, strlen($s)-2);
    else return $s;
}

?>
