<?php
/*
    usage {recent_comments
                max=5  →デフォルトは5
*/

function smarty_insert_recent_comments( $params, &$smarty ){

    if ( !isset($params['max']) ) $params['max'] = 5;

    $smarty_recent_comments = new smarty_c;
    $smarty_recent_comments_cache_id = 'recent_comments|' . which_view();
//echo $smarty_recent_comments_cache_id;
    $smarty_recent_comments->caching = 2;
    $smarty_recent_comments->cache_lifetime = -1; 
    if ( !$smarty_recent_comments->is_cached( 'recent_comments.tpl', $smarty_recent_comments_cache_id ) ) {
        process_recent_comments( $smarty_recent_comments, $params );
    }
    return $smarty_recent_comments->fetch('recent_comments.tpl', $smarty_recent_comments_cache_id );
}
function process_recent_comments( &$smarty_recent_comments, $params ){
    $last_comment_number = get_last_comment_number();
    if ( $last_comment_number === false ) return;
    $comment_number = $last_comment_number;
    $comment_found = 0;
    for ( $i = $comment_number; $comment_found < $params['max'] and $i >= 0; $i-- ){
        $recent_comment_w = get_comment( $i, false );
        if ( $recent_comment_w ){
            $comment_found++;
//        echo '<pre>**';var_dump($recent_comment_w);echo '**';
            if ( !isset( $recent_comment_entry[$recent_comment_w['entry_id']]) ){
                $recent_comment_entry[$recent_comment_w['entry_id']] = 
                    get_entry($recent_comment_w['entry_id']);
            }
            $recent_comment_entry[$recent_comment_w['entry_id']]['comment'][$i] = 
                $recent_comment_w;
        }
    }
//    echo '<pre>';
//    var_dump($recent_comment_entry);
    array_walk_recursive( $recent_comment_entry, 'array_specialchars' );
    $smarty_recent_comments->assign( 'recent_comment_entry', $recent_comment_entry );
}
?>