<?php
/*
    usage {recent_entries
                max=5  →デフォルトは5
*/

function smarty_insert_recent_entries( $params, &$smarty ){

    if ( !isset($params['max']) ) $params['max'] = 5;

    $smarty_recent_entries = new smarty_c;
    $smarty_recent_entries_cache_id = 'recent_entries|' . which_view();
//echo $smarty_recent_entries_cache_id;
    $smarty_recent_entries->caching = 2;
    $smarty_recent_entries->cache_lifetime = -1; 
    if ( !$smarty_recent_entries->is_cached( 'recent_entries.tpl', $smarty_recent_entries_cache_id ) ) {
        process_recent_entries( $smarty_recent_entries, $params );
    }
    return $smarty_recent_entries->fetch('recent_entries.tpl', $smarty_recent_entries_cache_id );
}
function process_recent_entries( &$smarty_recent_entries, $params ){
    $cache = read_cache();
    $entry_number = end($cache);
    for ( $i = 0; $i < $params['max'] and $entry_number !== false; $i++ ){
        $recent_entry[$entry_number] = get_entry( $entry_number );
        $entry_number = prev($cache);
    }
    array_walk_recursive( $recent_entry, 'array_specialchars' );
    $smarty_recent_entries->assign( 'recent_entry', $recent_entry );
}
?>