<?php
/*
    usage {recent_trackbacks
                max=5  →デフォルトは5
*/

function smarty_insert_recent_trackbacks( $params, &$smarty ){

    if ( !isset($params['max']) ) $params['max'] = 5;

    $smarty_recent_trackbacks = new smarty_c;
    $smarty_recent_trackbacks_cache_id = 'recent_trackbacks|' . which_view();
//echo $smarty_recent_trackbacks_cache_id;
    $smarty_recent_trackbacks->caching = 2;
    $smarty_recent_trackbacks->cache_lifetime = -1; 
    if ( !$smarty_recent_trackbacks->is_cached( 'recent_trackbacks.tpl', $smarty_recent_trackbacks_cache_id ) ) {
        process_recent_trackbacks( $smarty_recent_trackbacks, $params );
    }
    return $smarty_recent_trackbacks->fetch('recent_trackbacks.tpl', $smarty_recent_trackbacks_cache_id );
}
function process_recent_trackbacks( &$smarty_recent_trackbacks, $params ){
    $last_trackback_number = get_last_trackback_number();
    if ( $last_trackback_number === false ) return;
    $trackback_number = $last_trackback_number;
    $trackback_found = 0;
    for ( $i = $trackback_number; $trackback_found < $params['max'] and $i >= 0; $i-- ){
        $recent_trackback_w = get_trackback( $i, false );
        if ( $recent_trackback_w ){
            $trackback_found++;
//        echo '<pre>**';var_dump($recent_trackback_w);echo '**';
            if ( !isset( $recent_trackback_entry[$recent_trackback_w['entry_id']]) ){
                $recent_trackback_entry[$recent_trackback_w['entry_id']] = 
                    get_entry($recent_trackback_w['entry_id']);
            }
            $recent_trackback_entry[$recent_trackback_w['entry_id']]['trackback'][$i] = 
                $recent_trackback_w;
        }
    }
//    echo '<pre>';
//    var_dump($recent_trackback_entry);
    array_walk_recursive( $recent_trackback_entry, 'array_specialchars' );
    $smarty_recent_trackbacks->assign( 'recent_trackback_entry', $recent_trackback_entry );
}
?>