<?php
require_once('./setup.php');
performance('init');
require_once('moblog.php');
moblog();
$this_is = guess_this_is();
if ( $this_is['type'] <> 'rss' ){
    require_once('login_func.php');
    gb_session_start();
}

$smarty = new smarty_c;
//$smarty->debugging = false;
if (  !isset( $_REQUEST['do'] ) ) {
    readlock();

    $smarty_cache_id = gt_smarty_cache_id($this_is);
//echo $smarty_cache_id;
    $smarty->caching = 2;
    $smarty->cache_lifetime = -1; 
    if ( !$smarty->is_cached( 'index.tpl', $smarty_cache_id ) ) {
        $this_is = get_this_is();
        $smarty_cache_id = gt_smarty_cache_id($this_is);
        process_all_normal( $smarty, $this_is );
    }
}
else {
    writelock();
    $smarty_cache_id = gt_smarty_cache_id($this_is);
    $smarty->caching = false;
    process_all_do( $smarty, $this_is );
}
//$smarty->display( 'index.tpl', $smarty_cache_id );
if ($this_is['type'] == 'rss' ){
    header("Content-Type: application/xml");
    $smarty->cache_modified_check = true;
    $smarty->debugging = false;
}
if ( which_view() == 'mobile_view' ){
    $out = $smarty->fetch( 'index.tpl', $smarty_cache_id );
    header('Content-Type: text/html; charset=shift_jis');
    echo mb_convert_encoding($out, 'SJIS', 'UTF-8');
} else {
    $smarty->display( 'index.tpl', $smarty_cache_id );
}
//echo '<div id="performance" style="text-align : left;">処理時間' . performance() . '秒</div>';
//echo '<div id="footer" style="text-align : right;top : 1px;left : 0px;position : absolute;">処理時間' . performance() . '秒</div>';

exit;

function process_all_normal( &$smarty, $this_is ){
//    print_r($this_is);
    switch ( $this_is['type'] ){
    case "rss":
        process_rss_request( $smarty, $this_is );
        break;
    case "entry":
        process_entry_request( $smarty, $this_is );
        break;
    case "page":
        process_page_request( $smarty, $this_is );
        break;
    case "month":
        process_month_request( $smarty, $this_is );
        break;
    case "error":
        process_error_request( $smarty, $this_is );
        break;
    }
    $smarty->assign( 'trackback', master_trackback() );
}
function process_rss_request( &$smarty, $this_is ) {
    $master_blog = master_blog();

        $cache = read_cache();
//        echo '<pre>';
//        print_r( $cache );
        if ( count($cache) > $master_blog['rss_view']['count'] ){
            $disp_last_entry_number = count($cache)-1;
            $disp_first_entry_number = count($cache) - $master_blog['rss_view']['count'];
        } else {
            $disp_last_entry_number = count($cache)-1;
            $disp_first_entry_number = 0;
            
        }

        $entry = array();
        for ( $i = $disp_last_entry_number; $i >= $disp_first_entry_number; $i-- ){
            $work_entry = get_entry_all( $cache[$i], true );
            translate_entry_for_display( $work_entry );
            if ( $work_entry ) $entry[$cache[$i]] = $work_entry;
        }

        $attributes = $this_is;

        $smarty->assign('blog', $master_blog );
        $smarty->assign('attributes', $attributes );

        $smarty->assign( 'entry', $entry );
        return true;
//    } else {
//        echo 'category request';
//    }
 
}
function process_page_request( &$smarty, $this_is ) {
    $master_blog = master_blog();

        $cache = read_cache( $this_is['category_id'] );

        $last_page_number = count_to_last_page_number( count($cache), which_view() );

        list( $disp_first_entry_number, $disp_last_entry_number ) =
            disp_first_last_cnumber( $this_is['value'], $this_is['category_id'], which_view() );

        $entry = array();
        for ( $i = $disp_last_entry_number; $i >= $disp_first_entry_number; $i-- ){
            $work_entry = get_entry_all( $cache[$i], true );
            translate_entry_for_display( $work_entry );
            if ( $work_entry ) $entry[$cache[$i]] = $work_entry;
        }

        $attributes = $this_is;

        $smarty->assign('blog', $master_blog );
        $smarty->assign('attributes', $attributes );

        $smarty->assign( 'entry', $entry );
        return true;
//    } else {
//        echo 'category request';
//    }
 
}

function process_entry_request( &$smarty, $this_is ) {
    $master_blog = master_blog();
    $work_entry = get_entry_all( $this_is['value'], true );
    translate_entry_for_display( $work_entry );
    $entry[$this_is['value']] = $work_entry;

    $attributes = $this_is;
    
    $last_entry_number = get_last_entry_number();
    $attributes['last_number'] = $last_entry_number;

    $cache = read_cache( $this_is['category_id'] );
//    $attributes['list'] = $cache;
        
    $smarty->assign('blog', $master_blog );
    $smarty->assign('attributes', $attributes );
//    $smarty->gakiblo_attributes = $attributes;
    $smarty->assign( 'entry', $entry );
    return true;
}
function process_month_request( &$smarty, $this_is ) {
    $master_blog = master_blog();
//    if ( $this_is['category_id'] == 'all' ){
        $cache = read_cache( 'all', $this_is['value'] );
//        forreach( $cache as $entry_no ){
//            $work_entry = get_entry_all( $entry_no, false );
//            translate_entry_for_display( $work_entry );
//            if ( $work_entry ) $entry[$entry_no] = $work_entry;
        for ( $i = count($cache) -1 ; $i >= 0 ; $i -- ) {
            $work_entry = get_entry_all( $cache[$i], true );
            translate_entry_for_display( $work_entry );
            if ( $work_entry ) $entry[$cache[$i]] = $work_entry;
        }

        $attributes = $this_is;

        $smarty->assign('blog', $master_blog );
        $smarty->assign('attributes', $attributes );

        $smarty->assign( 'entry', $entry );
        return true;
//    } else {
//        echo 'category request';
//    }
 
}
function process_error_request( &$smarty, $this_is ) {
    $master_blog = master_blog();
       $attributes = $this_is;

        $smarty->assign('blog', $master_blog );
        $smarty->assign('attributes', $attributes );

        return true;

 
}

function process_all_do( &$smarty, $this_is ){

  require_once('login_func.php');
  $login_info = gb_login_info();
  $ok = false;
  if ( $login_info ){
    switch ( $this_is['what'] ){
    case "entry":
        require_once('do_entry.php');
        if ( isset($_REQUEST['insert'])){
            do_insert_entry( $smarty );
        } elseif ( isset($_REQUEST['preview'])){
            do_preview_entry( $smarty );
        } elseif ( isset($_REQUEST['update'])){
            do_update_entry( $smarty );
        } elseif ( isset($_REQUEST['delete'])){
            do_delete_entry( $smarty );
        } elseif ( isset($_REQUEST['entry'])){
            do_get_entry( $smarty );
        } else {
            do_new_entry( $smarty );
        }
        $ok = true;
        break;
    case "comment":
        require_once('do_comment.php');
        if ( isset($_REQUEST['insert'])){
            do_insert_comment( $smarty );
        } elseif ( isset($_REQUEST['update'])){
            do_update_comment( $smarty );
        } elseif ( isset($_REQUEST['delete'])){
            do_delete_comment( $smarty );
        } else {
            do_get_comment( $smarty );
        }
        $ok = true;
        break;
    case "trackback":
        require_once('do_trackback.php');
        if ( isset($_REQUEST['update'])){
            do_update_trackback( $smarty );
        } elseif ( isset($_REQUEST['delete'])){
            do_delete_trackback( $smarty );
        } else {
            do_get_trackback( $smarty );
        }
        $ok = true;
        break;
    case "show_trackback_url":
        $entry_id = $_REQUEST['entry'];
        $entry_rec = get_entry_all( $entry_id, false );
        if ( $entry_rec ){
            translate_entry_for_display( $entry_rec );
            $entry[$entry_id] = $entry_rec;
            $smarty->assign('entry', $entry);
        }
        $ok = true;
        break;
    }
  } else {
    switch ( $this_is['what'] ){
    case "comment":
        require_once('do_comment.php');
        if ( isset($_REQUEST['insert'])){
            do_insert_comment( $smarty );
            $ok = true;
        }
        break;
    case "show_trackback_url":
        $entry_id = $_REQUEST['entry'];
        $entry_rec = get_entry_all( $entry_id, false );
        if ( $entry_rec ){
            translate_entry_for_display( $entry_rec );
            $entry[$entry_id] = $entry_rec;
            $smarty->assign('entry', $entry);
        }
        $ok = true;
        break;
    }
  }

  if ($ok){
    $attributes['view'] = which_view();
    $attributes['type'] = 'entry';
    $attributes['value'] = $_REQUEST['entry'];
    $attributes['category'] = 'all';
    $smarty->assign( 'attributes', $attributes );
    $smarty->assign( 'do', $this_is['what'] );
    $smarty->assign( 'do_entry', $_REQUEST['entry'] );
  } else {
    $attributes['view'] = which_view();
    $attributes['type'] = 'entry';
    $attributes['value'] = $_REQUEST['entry'];
    $attributes['category'] = 'all';
    $smarty->assign( 'attributes', $attributes );
    $smarty->assign( 'do', 'error' );
    $smarty->assign( 'loginerror', true );

    if ( $_REQUEST['entry'] <> '' ){
        $entry_rec = get_entry_all( $_REQUEST['entry'], false );
        
        if ( $entry_rec ){
            translate_entry_for_display( $entry_rec );
            $entry[$_REQUEST['entry']] = $entry_rec;
            $smarty->assign( 'entry', $entry );
        }
    }
  }
  $smarty->assign( 'blog', master_blog() );
  $smarty->assign( 'trackback', master_trackback() );
  $smarty->assign( 'user_options', user_options() );
  $smarty->assign( 'category_options', category_options() );
  $smarty->assign( 'status_options', status_options() );
}
/* 指示された内容をフィルタリングし、キャッシュに使うページ情報
を得る。
 */
function guess_this_is(){
    $do = $_REQUEST['do'];
    $e = $_REQUEST['e'];
    $p = $_REQUEST['p'];
    $m = $_REQUEST['m'];
    $c = $_REQUEST['c'];
    
    $rss = $_REQUEST['rss'];
    $this_is['view'] = which_view();
    
    if ( isset($rss) ){
        $this_is['type'] = 'rss';
        return $this_is;
    }

    $this_is['view'] = which_view();

    if ( isset($do) ){
        $this_is['type'] = 'do';
        $this_is['what'] = $do;
        $this_is['entry'] = $_REQUEST['entry'];
        
        /* insert,delete,update */
        return $this_is;
    }
    if ( isset($m) ){
            $this_is['type'] = 'month';
            $this_is['value'] = $m;
            $this_is['category_id'] = 'all';
            $this_is['category_name'] = '';
            return $this_is;
    }
    if ( isset($c) ){
        $c = (int) $c;
    } else {
        $c = 'all';
    }
    
    if ( isset($e) ){
        $e = (int) $e;
            $this_is['type'] = 'entry';
            $this_is['value'] = $e;
            $this_is['category_id'] = $c;
            $this_is['category_name'] = $cname;
    }
    elseif ( isset($p) ){
        $p = (int) $p;
        $this_is['type'] = 'page';
        $this_is['value'] = $p;
        $this_is['category_id'] = $c;
    } else {
        $this_is['type'] = 'page';
        $this_is['value'] = 'last';
        $this_is['category_id'] = $c;
    }
    return $this_is;
}

function get_this_is(){
    $do = $_REQUEST['do'];
    $e = $_REQUEST['e'];
    $p = $_REQUEST['p'];
    $m = $_REQUEST['m'];
    $c = $_REQUEST['c'];
    
    $rss = $_REQUEST['rss'];
    $this_is['view'] = which_view();
    
    if ( isset($rss) ){
        $this_is['type'] = 'rss';
        return $this_is;
    }

    $master_blog = master_blog();

    

    if ( isset($do) ){
        $this_is['type'] = 'do';
        $this_is['what'] = $do;
        $this_is['entry'] = $_REQUEST['entry'];
        
        /* insert,delete,update */
        return $this_is;
    }
    if ( isset($m) ){
        $w = read_cache( 'all', $m );
        if ( !$w ) {
            $this_is['type'] = 'error';
            return $this_is;
        } else {
            $this_is['type'] = 'month';
            $this_is['value'] = $m;
            $this_is['category_id'] = 'all';
            $this_is['category_name'] = '';
            return $this_is;
        }
    }
    $cache = array();
    if ( isset($c) ){
        $categories = master_category();
        if ( isset($categories[$c]) ){
             $c = (int) $c;
             $cname = $categories[$c]['name'];
             $cache = read_cache($c);
        }
        else {
            $this_is['type'] = 'error';
            return $this_is;
        }
    } else {
        $c = 'all';
        $cname = '';
        $cache = read_cache($c);
    }
    
    if ( isset($e) ){
        $e = (int) $e;
//        $last = count($cache) - 1;


        if ( array_search( $e, $cache ) === false){
            $this_is['type'] = 'error';
            return $this_is;
        } else {
            $this_is['type'] = 'entry';
            $this_is['value'] = $e;
            $this_is['category_id'] = $c;
            $this_is['category_name'] = $cname;
        }
    }
    elseif ( isset($p) ){
        $p = (int) $p;
//        if ( $p < 0 ) $p = 0;
        $last = count_to_last_page_number ( count($cache), $this_is['view'] );

        if ( $p > $last or $p < 1) {
            $this_is['type'] = 'error';
            return $this_is;
        }
        else {
            $this_is['type'] = 'page';
            $this_is['value'] = $p;
        }
        $this_is['category_id'] = $c;
        $this_is['category_name'] = $cname;
    } else {
        $this_is['type'] = 'page';
        $this_is['value'] = 'last';
        $this_is['category_id'] = $c;
        $this_is['category_name'] = $cname;
    }
/*
    if ( $this_is['type'] == 'page' ){
        $last_entry_number = count($cache) - 1;
        if ( $last_entry_number <  $master_blog[$this_is['view']]['top_page_count'] ){
             $last_page_number = -1;
        } else {
             $last_page_number =
                (int) ( ( $last_entry_number -  
                            $master_blog[$this_is['view']]['top_page_count']
                           ) /
                           $master_blog[$this_is['view']]['past_page_count'] 
                      );
        }
        $this_is['last_number'] = $last_page_number;
    }
*/
    return $this_is;
}
function gt_smarty_cache_id( $this_is ){
    if ( $this_is['type'] == 'rss' ){
        $smarty_cache_id = $this_is['type'] . '|' .
	    $this_is['view'];
    } elseif ( $this_is['type'] == 'entry' ){
        $smarty_cache_id = 
	    $this_is['type'] . '|' . 
	    $this_is['value'] . '|' .
	    $this_is['view'];
    } else {
        $smarty_cache_id = 
	    $this_is['type'] . '|' . 
	    $this_is['category_id'] . '|' .
	    $this_is['value'] . '|' .
	    $this_is['view'];
    }
    return $smarty_cache_id;

}

?>
