<?php
require_once('./setup.php');


require_once('login_func.php');
gb_session_start();
require_once('http.php');
$login_info = gb_login_info();
if ( !$login_info ){
    echo 'ログインしていないか、セッションタイムアウトです。再度ログインしてください。';
    exit;
}

$smarty = new smarty_c;
$smarty->caching = false;

$master_blog = master_blog();
$master_upload = master_upload();

$smarty->assign('blog', $master_blog );

$entry_id = $_REQUEST['entry'];

//print_r($_REQUEST);

$entry_rec = get_entry_all( $entry_id );
if ( !$entry_rec ){
    user_error('エントリーがありません。バグ？');
    exit;
}
$errors = array();
$messages = array();

//print_r($entry_rec);
$urls = list_atag_href( $entry_rec['introduction'] . $entry_rec['body'] );
$smarty->assign( 'urls', $urls );

if ( count($urls) <= 0 ) {
    $errors[] = "本文中にＵＲＬがありませんので、トラックバックできません。";
    $smarty->assign( 'errors', $errors );
    $smarty->display( 'send_trackback.tpl' );
    exit;
}

if ( isset($_REQUEST['trackback'])){
        $trackback_list = $_REQUEST['s'];
        $w_trackback_list = array();
        foreach ( $trackback_list as $k => $v ){
            if ( $v['checked'] ) {
                if ( !preg_match("@^(http|https)://.+/.*@i", $v['trackback_url']  ) ){
                    $errors[] = '[' . $v['trackback_url'] . ']トラックバックＵＲＬを正しく入力してください。';
                } else {
                    $w_trackback_list[$k] = $v;
                }
            }
        }
        if ( !$w_trackback_list ){
            $errors[] = '少なくとも１つは、トラックバック先を指定してください。';
        }
        $trackback_contents = $_REQUEST['tc'];

        if  ( !preg_match("@^(http|https)://.+/.*@i", $trackback_contents['url']  ) ){
                    $errors[] = '[' . $trackback_contents['url'] . ']ＵＲＬを正しく入力してください。';
        }
        if ( $errors ){
            
        } else {
            foreach ( $w_trackback_list as $k => $v ){
                $ret = do_trackback( $v, $trackback_contents, $errors, $messages );
                if ( $ret ) unset( $trackback_list[$k] );
            }
        }
        
        $smarty->assign( 'trackback_list', $trackback_list );
        $smarty->assign( 'trackback_contents', $trackback_contents );
} else {
    //echo '*';var_dump($urls);
    foreach ( $urls as $k => $url ) {
        $trackback_list[$k]['url'] = $url;
        $http_status = get_trackback_url( $url, $trackback_urls, $not_match_urls );
        if ( $http_status !== '200' ){
            $errors[] = "[" . $url . "]からのHTTP-status戻り値が、[" . $http_status . "]です。URLに間違いないか確認してください。";
        }
/*
        echo 'http_status' . $http_status . ".";
        echo 'url';
        echo $url;
        echo 'trackbackurl';
        print_r( $trackback_urls );
        echo 'notmatchurl';
        print_r( $not_match_urls );
*/
        $trackback_list[$k]['trackback_url'] = $trackback_urls[0];
        $trackback_list[$k]['not_match_urls'] = $not_match_urls;
        if ( count($trackback_urls) > 0 ) $trackback_list[$k]['checked'] = true;

        if ( count($trackback_urls) > 1 ){
            $errors[] = "[" . $url . "]に、ＵＲＬが合致するトラックバックＵＲＬが複数あり、最初の１つを表示しています。";
        } elseif ( count($trackback_urls) == 0 ) {
            $errors[] = "[" . $url . "]で、ＵＲＬが合致するトラックバックＵＲＬが自動検出できませんでした。URLを確認し、合っていれば手動でトラックバックURLを指定してください。";

        }
        if ( count($not_match_urls) > 0 ) {
            $errors[] = "[" . $url . "]には、URLが合致しないトラックバックＵＲＬが" . count($not_match_urls) ."個あります。URLを確認してください。";
        }
        $smarty->assign( 'trackback_list', $trackback_list );
    }

    $trackback_contents['title'] = $entry_rec['title'];
    $trackback_contents['excerpt'] = strip_tags(convert_input_tag($entry_rec['introduction']));
    $trackback_contents['url'] = $master_blog['url'] . '?e=' . $entry_id;
    $trackback_contents['blog_name'] = $master_blog['name'];
    $smarty->assign( 'trackback_contents', $trackback_contents );
}
$smarty->assign( 'errors', $errors );
$smarty->assign( 'messages', $messages );
$smarty->display( 'send_trackback.tpl');
exit;

function do_trackback( $trackback, $trackback_contents, &$errors, &$messages ){
//    print_r($trackback);print_r($trackback_contents);
//    return true;
    $ret_last = true;    
    list( $header, $body) = http( $trackback['trackback_url'], "POST", 
        "Content-Type: application/x-www-form-urlencoded\r\nUser-Agent: gakiblo\r\n", 
        $trackback_contents );
    $http_responses = explode(" ", $header, 3 );
    if ( $http_responses[1] <> '200'){
        $errors[] = "[" . $trackback['trackback_url'] . "]からのHTTP-status戻り値が、[" . $http_status . "]です。URLに間違いないか確認してください。";
        $ret_last = false;
    }
//    echo "*****head************";
//    echo $header;
//    echo "*****body***********";
//    echo $body;
//    echo "*****end***********";
    preg_match( "@<error>(.*?)</error>@si", $body, $match_e );
//    print_r($match_e);
    if ( !isset($match_e[1]) or $match_e[1] <> '0' ){
        $ret_last = false;
    }
    preg_match( "@<message>(.*?)</message>@si", $body, $match_m );    
//    print_r($match_m);
    if ( $ret_last ){
        $messages[] = '[' . $trackback['trackback_url'] . ']に対するトラックバックが成功しました。' .
            'エラー[' . $match_e[1] . '],メッセージ[' . $match_m[1] . ']';
        return true;
    } else {
        $errors[] = '[' . $trackback['trackback_url'] . ']に対するトラックバックが失敗しました。' .
            'エラー[' . $match_e[1] . '],メッセージ[' . $match_m[1] . ']';
        return false;
    }
}
function list_atag_href( $subject ){
        $rettags=array();
        preg_match_all( "/<([^>]*)>/", $subject, $html_tags);
        foreach( $html_tags[1] as $html_tag ){
                preg_match( "/a.*href=\"(http[^\"]*)\"/i",$html_tag, $a_tags);
                if ( $a_tags ) $rettags[] = $a_tags[1];
        }
        return $rettags;
}
function get_trackback_url( $url, &$trackback_url, &$not_match_url ){
    $trackback_url = array();
    $not_match_url = array();
    list( $header, $body) = http( $url, "GET", "User-Agent: gakiblo\r\n" );
//    echo $header;
    
    $http_responses = explode(" ", $header, 3 );
    preg_match_all( "@<rdf:RDF(.*?)</rdf:RDF>@s", $body, $rdf_segments );
    foreach ( $rdf_segments[1] as $rdf_segment ){
//        echo $rdf_segment;
//        echo "**********seg**********\n";
        preg_match_all( "@<rdf:Description(.*?)/>@s", $rdf_segment, $rdf_descriptions);
        foreach ( $rdf_descriptions[1] as $rdf_description ){
//            echo $rdf_description;
//            echo "**********desc**********\n";
            preg_match( "@dc:identifier=\"([^\"]+)@", $rdf_description, $dcid );
//            echo $dcid[1];
//            echo "*************************\n";
            if ( $dcid[1] == $url ){
                preg_match("@trackback:ping=\"([^\"]+)@", $rdf_description, $tbping );
                $trackback_url[] = $tbping[1];
            } else {
                $not_match_url[] = $dcid[1];
            }
        }
    }
    return $http_responses[1];
}

?>