<?php
require_once('./setup.php');

//error_log(print_r($_REQUEST,true),3,"t.dat");
header("Content-Type: application/xml");

$request['title'] = $_REQUEST['title'];
$request['body'] = mb_strimwidth( $_REQUEST['excerpt'],0,252,'...');
$request['url'] = $_REQUEST['url'];
$request['blog_name'] = $_REQUEST['blog_name'];
$request['date'] = mktime();
$request['ip'] = $_SERVER["REMOTE_ADDR"];
$request['host'] = gethostbyaddr($_SERVER["REMOTE_ADDR"]);
$request['user_agent'] = $_SERVER["HTTP_USER_AGENT"];

$entry_id = $_REQUEST['e'];
$request['k'] = $_REQUEST['k'];

$ret = check_convert_requested_data( $request, $output, $error );
if ( !$ret ){
    echo_trackback_response( false, $error );
    exit;
}

$entry_rec = get_entry_all( $entry_id, false );
//var_dump($entry_rec);
if ( !$entry_rec or $entry_rec['status'] <> 'Publish'){
    echo_trackback_response( false, 'Entry not exist' );
    exit;
} elseif ( !$entry_rec['allow_pings'] ){
    echo_trackback_response( false, 'Not allowed trackback to this entry' );
    exit;
}

//これまでのチェックは、通常チェック。
//次のチェックはSPAM対策とかで、手口を知りたいので、管理人にメールする上、
//理由は、教えてあげない。
$ret = check_trackback_spam( $entry_id, $output, $reasons);
if ( !$ret ){
    mail_trackback_result( $entry_id, $entry_rec, $request, false, $reasons );
    echo_trackback_response( false, 'Unknown Error' );
    exit;
}

writelock();
$smarty = new smarty_c;
$ret = insert_trackback( $entry_id, $output, $trackback_id);
if (!$ret ){
        user_error('トラックバック作成に失敗しました',E_USER_WARNING);
        exit;
}
$del_smarty_cache = list_trackback_smarty_cache( $entry_id, $entry_rec['category_id'] );

//    echo '<pre>';
//    print_r( $del_smarty_cache );

foreach ( $del_smarty_cache as $v){
    $smarty->clear_cache(null, $v );
}

mail_trackback_result( $entry_id, $entry_rec, $request, true );
echo_trackback_response( true, "Trackback Accepted by Gakiblo" );
exit;

function mail_trackback_result( $entry_id, $entry_rec, $request, $ok, $reasons = array() ){
    $master_user = master_user();
    $user_rec = $master_user[$entry_rec['user_id']];
//    print_r($user_rec);
    if ( $user_rec['smtp_host'] and $user_rec['mail_address'] ){
        $master_blog = master_blog();
        if ( $ok ) $w = '受信'; else $w = '拒否';
        $mail_subject = '[' . $master_blog['name'] . '][トラックバック' .$w. ']';
        $mail_subject .= $entry_rec['title'];
        $mail_body = '';
        $mail_body .= "トラックバックを" . $w . "しました。\r\n";
        if ( !$ok )
        $mail_body .= "拒否理由:" . implode(',',$reasons) . "\r\n";
        $mail_body .= "参照URL:" . $master_blog['url'] . "?e=$entry_id#trackback\r\n";
        $mail_body .= "******************************************************************\r\n";
        $mail_body .= "タイトル:              " . $request['title'] . "\r\n";
        $mail_body .= "URL:                   " . $request['url'] . "\r\n";
        $mail_body .= "ブログ名:              " . $request['blog_name'] . "\r\n";
        $mail_body .= "投稿者ホスト:          " . gethostbyaddr($request['ip']) . "\r\n";
        $mail_body .= "投稿者ホストUser-Agent:\r\n";
        $mail_body .= $request['user_agent'] . "\r\n";
        $mail_body .= "要約:\r\n";
        $mail_body .= $request['body'] . "\r\n";
        $mail_body .= "******************************************************************\r\n";
        
        
        require_once('gb_mail.php');
        $ret = @gb_mail( $user_rec['smtp_host'], $request['blog_name'], $user_rec['mail_address'],
                        $user_rec['mail_address'], $mail_subject, $mail_body );
//        if (!$ret) user_error("通知メール送信に失敗しました。");
    }

}
function echo_trackback_response( $ok, $message){
    echo "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\r\n";
    echo "<response>\r\n";
    if ( $ok ){
        echo "<error>0</error>\r\n";
    } else {
        echo "<error>1</error>\r\n";
    }
    echo "<message>$message</message>\r\n";
    echo "</response>\r\n";
}
function check_convert_requested_data( $request, &$output, &$error ){
    $master_trackback = master_trackback();
    $output = $request;

    // 通常のチェック、ＵＲＬは必須
    if ( $request['url'] == '' ){
        $error = 'You must specify URL';
        return false;
    } elseif ( $master_trackback['maxlen_url'] and strlen( $request['url'] ) > $master_trackback['maxlen_url'] ){
        $error = 'URL is too long';
        return false;
    }

    if ( $master_trackback['maxlen_title'] ) 
        $output['title'] = mb_strimwidth( $request['title'],0,$master_trackback['maxlen_title'],'...');
    if ( $master_trackback['maxlen_excerpt'] ) 
        $output['body'] = mb_strimwidth( $request['body'],0,$master_trackback['maxlen_excerpt'],'...');
    if ( $master_trackback['maxlen_blog_name'] ) $output['blog_name'] = mb_strimwidth( $request['blog_name'],0,$master_trackback['maxlen_blog_name'],'...');

    return true;
}
function check_trackback_spam($entry_id, $output, &$reasons ){
    $master_trackback = master_trackback();
    $ret_last = true;
    $reasons = array();
    // ユーザーエージェントがMozilla等含まれる場合は、ＰＣからなのでエラー
    if ( preg_match( $master_trackback['reject_user_agent'], $output['user_agent'] ) ){
        $reasons[] = "ユーザーエージェントが、" . $master_trackback['reject_user_agent'] .
                    "に一致します。";
        $ret_last = false;
    }

    // ユーザーエージェントがMozilla/　で始まる場合は、ＰＣからなのでエラー
    if ( $master_trackback['sup_string'] <> '' and  
         !isset($_REQUEST[ $master_trackback['sup_string']])){
        $reasons[] = "トラックバックURLに、" .$master_trackback['sup_string'] .
                    "が含まれない。";
        $ret_last = false;
    }

    //一応、ＵＲＬ指定は、gakiblo標準にあわせる。
    if ( !check_url($output['url']) ){
        $reasons[] = "ＵＲＬが不正";
        $ret_last = false;
    }
    
    if ( $master_trackback['timelimit_trackback_url'] ){
        $now = mktime();
        if ( $output['k'] <> '' ){
          for( $i = 0; $i < TB_TIMELIMIT_NUM; $i++ ){
            $md5_key = md5_trackback_key_generate( $entry_id, $now-$i*TB_TIMELIMIT_UNIT, $b_time );
//            user_error('test'.$i);
//            user_error($md5_key);
//            user_error($output['k']);
            if ( $md5_key == $output['k'] ){
                $ret_m = true;
                break;
            }
            $ret_m = false;
          }
          if ( !$ret_m ){
            $reasons[] = "期限オーバーまたは、kが嘘";
            $ret_last = false;
          }
        } else {
            $reasons[] = "期限指定なのに、期限指定じゃないＵＲＬ";
            $ret_last = false;
        }

    }
    return $ret_last;

}



?>
